---
id: 5a23c84252665b21eecc8028
title: Stern-Brocot sequence
challengeType: 5
isHidden: false
forumTopicId: 302324
---

## Description

<section id='description'>
For this task, the Stern-Brocot sequence is to be generated by an algorithm similar to that employed in generating the <a href="https://rosettacode.org/wiki/Fibonacci sequence" target="_blank">Fibonacci sequence</a>.
<ol>
  <li>The first and second members of the sequence are both 1:</li>
    <ul><li>1, 1</li></ul>
  <li>Start by considering the second member of the sequence</li>
  <li>Sum the considered member of the sequence and its precedent, (1 + 1) = 2, and append it to the end of the
    sequence:</li>
    <ul><li>1, 1, 2</li></ul>
  <li>Append the considered member of the sequence to the end of the sequence:</li>
    <ul><li>1, 1, 2, 1</li></ul>
  <li>Consider the next member of the series, (the third member i.e. 2)</li>
  <li>GOTO 3 </li>
    <ul>
      <li></li>
      <li> ─── Expanding another loop we get: ───</li>
      <li></li>
    </ul>
  <li>Sum the considered member of the sequence and its precedent, (2 + 1) = 3, and append it to the end of the
    sequence:</li>
    <ul><li>1, 1, 2, 1, 3</li></ul>
  <li>Append the considered member of the sequence to the end of the sequence:</li>
    <ul><li>1, 1, 2, 1, 3, 2</li></ul>
  <li>Consider the next member of the series, (the fourth member i.e. 1)</li>
</ol>
</section>

## Instructions

<section id='instructions'>
Create a function that returns the $ n^{th} $ member of the sequence using the method outlined above.
</section>

## Tests

<section id='tests'>

```yml
tests:
  - text: <code>sternBrocot</code> should be a function.
    testString: assert(typeof sternBrocot == 'function');
  - text: <code>sternBrocot(2)</code> should return a number.
    testString: assert(typeof sternBrocot(2) == 'number');
  - text: <code>sternBrocot(2)</code> should return <code>3</code>.
    testString: assert.equal(sternBrocot(2), 3);
  - text: <code>sternBrocot(3)</code> should return <code>5</code>.
    testString: assert.equal(sternBrocot(3), 5);
  - text: <code>sternBrocot(5)</code> should return <code>11</code>.
    testString: assert.equal(sternBrocot(5), 11);
  - text: <code>sternBrocot(7)</code> should return <code>19</code>.
    testString: assert.equal(sternBrocot(7), 19);
  - text: <code>sternBrocot(10)</code> should return <code>39</code>.
    testString: assert.equal(sternBrocot(10), 39);
```

</section>

## Challenge Seed

<section id='challengeSeed'>
<div id='js-seed'>

```js
function sternBrocot(num) {
  // Good luck!
}
```

</div>
</section>

## Solution

<section id='solution'>

```js
function sternBrocot(num) {
  function f(n) {
    return n < 2
      ? n
      : n & 1
      ? f(Math.floor(n / 2)) + f(Math.floor(n / 2 + 1))
      : f(Math.floor(n / 2));
  }

  function gcd(a, b) {
    return a ? (a < b ? gcd(b % a, a) : gcd(a % b, b)) : b;
  }
  var n;
  for (n = 1; f(n) != num; n++);
  return n;
}
```

</section>
