---
id: 587d78b0367417b2b2512b05
title: Build a Technical Documentation Page
isRequired: true
challengeType: 3
forumTopicId: 301146
localeTitle: Создание страницы технической документации
---

## Description
<section id='description'>
<strong>Цель:</strong> создать приложение <a href="https://codepen.io" target="_blank">CodePen.io</a> , функционально подобное этому: <a href="https://codepen.io/freeCodeCamp/full/NdrKKL" target="_blank">https://codepen.io/freeCodeCamp/full/NdrKKL</a> . Выполните приведенные ниже <a href="https://en.wikipedia.org/wiki/User_story" target="_blank">истории пользователей</a> и получите все тесты для прохождения. Дайте ему свой личный стиль. Вы можете использовать HTML, JavaScript и CSS для завершения этого проекта. Рекомендуется использовать простой CSS, потому что это то, что до сих пор изучали уроки, и вы должны получить некоторую практику с простым CSS. Вы можете использовать Bootstrap или SASS, если вы выберете. Дополнительные технологии (например, jQuery, React, Angular или Vue) не рекомендуются для этого проекта, и использование их на свой страх и риск. Другие проекты дадут вам возможность работать с различными технологическими пакетами, такими как React. Мы примем и попытаемся исправить все отчеты о проблемах, которые используют предлагаемый стек технологий для этого проекта. Счастливое кодирование! <strong>User Story # 1:</strong> Я вижу <code>main</code> элемент с соответствующим <code>id=&quot;main-doc&quot;</code> , который содержит основное содержание страницы (техническая документация). <strong>User Story # 2:</strong> В элементе <code>#main-doc</code> я вижу несколько элементов <code>section</code> , каждый из которых имеет класс <code>main-section</code> . Должно быть не менее 5. <strong>User Story # 3:</strong> Первый элемент внутри каждого <code>.main-section</code> должен быть элементом <code>header</code> который содержит текст, описывающий тему этого раздела. <strong>User Story # 4:</strong> Каждый элемент <code>section</code> с классом <code>main-section</code> должен также иметь идентификатор, соответствующий тексту каждого содержащегося в нем <code>header</code> . Любые пробелы должны быть заменены символами подчеркивания (например, <code>section</code> который содержит заголовок «Javascript и Java», должен иметь соответствующий <code>id=&quot;Javascript_and_Java&quot;</code> ). <strong>User Story # 5:</strong> <code>.main-section</code> должны содержать не менее 10 <code>p</code> элементов (не каждый). <strong>User Story # 6:</strong> <code>.main-section</code> должны содержать не менее 5 элементов <code>code</code> (не каждый). <strong>User Story # 7:</strong> <code>.main-section</code> должны содержать не менее 5 элементов <code>li</code> (не каждый). <strong>User Story # 8:</strong> Я вижу элемент <code>nav</code> с соответствующим <code>id=&quot;navbar&quot;</code> . <strong>User Story # 9:</strong> элемент navbar должен содержать один элемент <code>header</code> который содержит текст, описывающий тему технической документации. <strong>User Story # 10:</strong> Кроме того, навигационная панель должна содержать элементы ссылки ( <code>a</code> ) с классом <code>nav-link</code> . Для каждого элемента с <code>main-section</code> классом класса должен быть один. <strong>User Story # 11:</strong> Элемент <code>header</code> на панели навигации должен появиться перед любыми элементами ссылки ( <code>a</code> ) на панели навигации. <strong>User Story # 12:</strong> Каждый элемент с классом <code>nav-link</code> должен содержать текст, соответствующий тексту <code>header</code> в каждом <code>section</code> (например, если у вас есть раздел / заголовок «Hello world», ваш навигатор должен иметь элемент, который содержит текст &quot;Привет мир&quot;). <strong>User Story # 13:</strong> Когда я нажимаю элемент navbar, страница должна перейти к соответствующему разделу элемента <code>main-doc</code> (например, если я нажму на элемент <code>nav-link</code> который содержит текст «Hello world», страница перемещается к элементу <code>section</code> который имеет этот идентификатор и содержит соответствующий <code>header</code> . <strong>User Story # 14:</strong> на устройствах с обычным размером (ноутбуки, настольные компьютеры) элемент с <code>id=&quot;navbar&quot;</code> должен быть показан в левой части экрана и должен всегда быть видимым пользователю. <strong>Пользовательская</strong> страница <strong>№15:</strong> страница «Моя техническая документация» должна использовать по крайней мере один мультимедийный запрос. Вы можете создать свой проект, <a href="http://codepen.io/freeCodeCamp/pen/MJjpwO" target="_blank">нарисуя это перо CodePen</a> . Или вы можете использовать эту ссылку CDN для запуска тестов в любой среде, : <code>https://cdn.freecodecamp.org/testable-projects-fcc/v1/bundle.js</code> После того, как вы закончите, отправьте URL-адрес вашему рабочему проекту со всеми его прохождениями тестов. Не забудьте использовать <a href="https://www.freecodecamp.org/forum/t/how-to-get-help-when-you-are-stuck-coding/19514" target="_blank">Read-Search-Ask</a> если вы застряли.
</section>

## Instructions
<section id='instructions'>

</section>

## Tests
<section id='tests'>

```yml
tests: []
```

</section>
