# freeCodeCamp 视频翻译计划

[freeCodeCamp's YouTube Channel](https://www.youtube.com/freecodecamp) 发布了大量优质视频教程，涵盖 HTML&CSS、JavaScript、Python、数据科学、机器学习等内容，我们一起把这些视频翻译成中文，发布在 [bilibili](https://space.bilibili.com/335505768)，分享给更多学员。

## 参与翻译你会获得

- 持续提升你的英文水平和多人协作的经验
- 成为 freeCodeCamp 社区贡献者（我们将在翻译后的视频介绍中记录译者的姓名或昵称）
- 有机会受邀参与 freeCodeCamp 城市社区的技术交流活动
- 在社区中结识优秀的小伙伴，拥抱更多技术成长与职业发展的可能性

## 协作流程
我们翻译的第一个视频是[零基础学 JavaScript（全套教程）](https://www.bilibili.com/video/av61884749/)，从这个过程中总结出协作流程的最佳实践如下（稍后我们可能对此进行优化）：
- **认领翻译：** 我们会先将 [freeCodeCamp's YouTube Channel](https://www.youtube.com/freecodecamp) 的原视频上传到 [bilibili](https://space.bilibili.com/335505768)，这样那些英语水平不错的人们可以先行观看学习。然后我们逐步为视频添加中文字幕。如果你有意参与翻译，请加微信好友（Hello_MrT）或发送邮件至 miya@freecodecamp.org，作简要的自我介绍，然后我们会把你想要翻译的视频的英文字幕文档发给你，并帮助你详细了解翻译过程中需要注意的地方。
- **语言水平要求：** 总的来说，英文字幕没有复杂的语法结构，没有生僻单词，对译者来说，英语四级的水平足够了。如果你之前有翻译经历或者用英语交流的经历，那就更棒啦！并且，你可以随时在协作群里和大家讨论，所以你真的真的不用太担心自己的英语水平。
- **技术水平要求：** 我们的视频教程有的是面向新手的，比如零基础学 JavaScript、零基础学 Python，这就不需要你有技术背景。而且当你遇到问题的时候，我们的开发者同学会为你解答，你可以在翻译过程中学习技术知识，逐渐掌握一门新技能。当然，有的视频教程是进阶性的，欢迎有技术背景的贡献者认领。
- **提交译文：** 翻译完成后，请将 .srt 格式的译文发至邮箱 miya@freecodecamp.org，注明译者姓名（或昵称），随后我们会在视频介绍中记录所有译者的姓名（或昵称）。
- **时间轴：** 在翻译过程中，译者不需要调整时间轴，也不要删除时间轴，我们会在上传的时候统一调整。
- **上传字幕：** 我们逐步将译文上传为外挂字幕，比如某个视频的一半的字幕已经翻译完毕，那么就先上传这一半的字幕。在完全上传并且校对无误之后，我们会下载包含时间轴的字幕终稿，并上传至 [freeCodeCamp's YouTube Channel](https://www.youtube.com/freecodecamp) 的视频。有大量中文用户在 YouTube 观看我们的视频教程，所以我们翻译的中文字幕也将帮助他们学习。特别感谢 [Chengjun.L](https://github.com/Raman0716) 编写脚本方便我们下载字幕终稿。
- **校对字幕：** 我们在上传字幕的时候同步进行校对。

## 翻译原则
结合翻译[零基础学 JavaScript（全套教程）](https://www.bilibili.com/video/av61884749/)的经验，我们简要总结翻译原则如下（稍后我们可能对此进行优化）：
- 句末不要加标点符号。
- 单句不宜过长，观众需要一眼就能看懂中文字幕。
- 灵活调整语序，比如英语里的 if 条件状语从句有时候是放在后部分，而中文翻译为“如果......”的时候，则需要放在前部分。
- 特别提醒没有技术背景的译者，当你遇到一些单词，拿不定主意，也许它是一个专业术语（比如，variable 变量，function 函数），这时候你可以直接在协作群里提出来讨论。
- 我们没有 deadline，请结合你自己的实际情况合理安排翻译时间，希望你享受协作的过程：D 不过，如果你在认领翻译之后发现自己短期内没时间翻译，请直接告诉我们，以便协调进度。

## 视频翻译进度
在选择你想翻译哪个视频之前，请在[这里](https://github.com/freeCodeCamp/videos-translation/wiki/%E8%A7%86%E9%A2%91%E7%BF%BB%E8%AF%91%E8%BF%9B%E5%BA%A6)查看其他贡献者已经翻译了哪些视频，避免重复翻译。
