<!-- do not translate this -->

| [Read these guidelines in other languages](/docs/i18n-languages) |
| ---------------------------------------------------------------- |


<!-- do not translate this -->

# Lignes directrices pour les contributions

Bonjour 👋 !

freeCodeCamp.org est possible grâce à des milliers de bénévoles comme vous. Nous sommes reconnaissants de vos contributions et nous sommes heureux de vous accueillir à bord.

Nous appliquons strictement notre [code de conduite]("Code of Conduct")(https://www.freecodecamp.org/code-of-conduct). Prenez un moment pour le lire. Il ne fait que 196 mots.

Bonne contribution 🎉 !

## Voici quelques façons amusantes d'aider

Vous pouvez choisir de contribuer dans n'importe quel domaine qui vous intéresse :

1. [Contribuez à cette base de code open source](#contribute-to-this-open-source-codebase). Aidez à l'édition des [articles du guide](https://guide.freecodecamp.org/), des [défis de codage](https://learn.freecodecamp.org/), ou en corrigeant des bugs sur la plateforme d'apprentissage.

2. Aidez les campeurs sur notre [forum public](https://www.freecodecamp.org/forum/). Répondez à leurs questions de code](https://www.freecodecamp.org/forum/?max_posts=1) ou [faites-leur un retour sur leurs projets de code](https://www.freecodecamp.org/forum/c/project-feedback?max_posts=1).

3. Aidez-nous à ajouter des sous-titres à nos vidéos sur [YouTube](https://www.youtube.com/channel/UC8butISFwT-Wl7EV0hUK0BQ/videos).

## Contribuer à cette base de code open source

Nous avons une énorme base de code open source composée de milliers de [défis de codage](https://learn.freecodecamp.org) et [d'articles de guide](https://guide.freecodecamp.org).

Vous pouvez nous aider par :

- [📝 Recherche, rédaction et mise à jour des articles de notre guide](#research-write-and-update-our-guide-articles)

- [💻 Création, mise-à-jour and correction de bogues dans nos défis de ](#create-update-andfix-bugs-in-our-coding-challenges)

- [🌐 Traduction des articles du guide et des défis de codage](#translate-guide-articles-and-coding-challenges)

- [🛠 Correction de bugs dans la plate-forme d'apprentissage freeCodeCamp.org](#help-us-fix-bugs-in-freecodecamporgs-learning-platform)

### Recherche, rédaction et mise à jour des articles de notre guide

**Que sont les articles du guide ?**

Les articles du guide vous aident à comprendre rapidement un concept technologique. Ce sont de brèves explications en français simple que vous pouvez lire avant de passer à des ressources plus approfondies.

Vous pouvez trouver un [exemple d'article sur les éléments d'ancrage HTML ici](https://github.com/freeCodeCamp/freeCodeCamp/blob/master/guide/french/html/elements/a-tag/index.md).

**Sur quoi puis-je écrire un article ?**

Nous vous invitons à nous aider à rédiger ces articles. Il n'est pas nécessaire d'être un expert en la matière pour écrire à ce sujet - ce guide est entièrement libre, donc même si vous faites une erreur, un autre contributeur la corrigera éventuellement.

Pour vous aider, trouvez un article sur notre [Guide](https://guide.freecodecamp.org), écrivez l'article, puis ouvrez une demande de retrait pour remplacer le talon par votre article. Une [demande de retrait](https://help.github.com/articles/about-pull-requests/) est la façon dont vous suggérerez des changements. Il permet aux autres de connaître, d'examiner et, éventuellement, d'adopter vos changements.

Si vous ne trouvez pas d'ébauche sur le sujet sur lequel vous aimeriez écrire, vous pouvez ouvrir un PR qui crée l'ébauche et inclut votre article provisoire.

Si vous souhaitez aider à améliorer les articles de guide, voici [comment travailler sur les articles de guide](/docs/how-to-work-on-guide-articles.md).

### Créer, mettre à jour et corriger des bugs dans nos défis de codage

Tous nos défis de codage sont organisés par la communauté, qui fait appel aux connaissances de bénévoles comme vous.

Vous pouvez aider à les développer et à rendre leur formulation plus claire. Vous pouvez mettre à jour les témoignages d'utilisateurs pour mieux expliquer le concept et même supprimer ceux qui sont redondants. Vous pouvez également améliorer les tests des défis pour qu'ils permettent de tester plus précisément le codage des personnes.

Si vous êtes intéressé à améliorer ces défis de codage, voici [comment travailler sur les défis de codage](/docs/how-to-work-on-coding-challenges.md).

### Traduire les articles du guide et les défis de codage

Vous pouvez nous aider à traduire les articles de notre Guide et les défis du codage dans la langue que vous parlez. Nous avons actuellement des versions traduites en :

- [Chinois (中文)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/chinese)
- [Russe (русский)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/russian)
- [Arabe (عربى)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/arabic)
- [Espagnol (Español)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/spanish)
- Portugais (Português)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/portuguese)
- Français (Français)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/french)

Nous aimerions que vous nous aidiez à améliorer la qualité de ces traductions. Des millions de personnes utilisent la version anglaise de freeCodeCamp.org, et nous nous attendons à ce que des millions d'autres utilisent également ces versions traduites.

### Aidez-nous à corriger des bugs sur la plateforme d'apprentissage freeCodeCamp.org

Notre plateforme d'apprentissage fonctionne sur une pile JavaScript moderne. Il a divers composants, outils et bibliothèques, y compris, mais sans s'y limiter à Node.js, MongoDB, LoopBack, OAuth 2.0, React, Gatsby, Webpack, et plus.

Dans l'ensemble,

- Nous avons un serveur API basé sur Node.js.
- Un ensemble d'applications client basées sur React.
- Un script que nous utilisons pour évaluer nos projets Frontend.

Pour y contribuer, il faut une certaine compréhension des APIs, de la syntaxe ES6 et beaucoup de curiosité.

Essentiellement, nous nous attendons à une connaissance de base de certaines des technologies, outils et bibliothèques susmentionnés. Cela dit, il n'est pas nécessaire d'être un expert en la matière pour contribuer.

N'hésitez pas à nous poser des questions sur les sujets connexes et nous serons heureux d'y répondre. En cas de doute, vous pouvez contacter Mrugesh Mohapatra [`@raisedadead`](https://github.com/raisedadead) ou Stuart Taylor [`@bouncey`](https://github.com/bouncey) de notre équipe de développement de plateforme pour vous aider.

**Si vous voulez nous aider à améliorer notre base de code, vous pouvez [configurer freeCodeCamp localement](/docs/how-to-setup-freecodecamp-locally.md) ou utiliser Gitpod, un outil de développement en ligne.**

[![Open in Gitpod](https://gitpod.io/button/open-in-gitpod.svg)](https://gitpod.io/#https://github.com/freeCodeCamp/freeCodeCamp)

(Commencez un _ready-to-code_ environnement de développement `freecodecamp` dans votre navigateur.)

## Foire aux questions

**Comment puis-je signaler un bug qui n'est pas à bord ?**

Si vous pensez avoir trouvé un bug, lisez d'abord l'article ["Help I've Found a Bug"](https://forum.freecodecamp.org/t/how-to-report-a-bug/19543) et suivez ses instructions.

Si vous êtes sûr qu'il s'agit d'un nouveau bug, allez-y et créez un nouveau ticket GitHub. Assurez-vous d'inclure autant d'informations que possible pour que nous puissions reproduire le bogue. Nous avons un modèle de ticket prédéfini pour vous y aider.

Veuillez noter que tous les tickets qui demandent de l'aide pour coder un défi seront fermés. Le système de suivi de tickets est strictement réservé aux questions et aux discussions liées à la base de code. En cas de doute, vous devriez [demander de l'aide sur le forum](https://www.freecodecamp.org/forum) avant de faire un rapport.

**Comment puis-je signaler un problème de sécurité ?**

Veuillez ne pas créer de tickets GitHub pour des raisons de sécurité. Envoyez plutôt un courriel à `security@freecodecamp.org` et nous nous en occuperons immédiatement.

**Que signifient ces différentes étiquettes qui sont étiquetées sur les problèmes ?**

Nos modérateurs de communauté [triage](https://en.wikipedia.org/wiki/Software_bug#Bug#Bug_management) traitent les problèmes et les demandes de retrait en fonction de leur priorité, de leur gravité et d'autres facteurs. Vous pouvez [trouver un glossaire complet de leur signification ici](https://github.com/freecodecamp/freecodecamp/labels).

Vous devriez passer en revue les tickets de **`Help Wanted`** ou **`first timers welcome`** pour avoir un aperçu rapide de ce qui est à votre disposition pour travailler dessus. Ils sont à votre disposition et vous n'avez pas besoin de demander la permission avant d'y travailler.

Si ces questions manquent de clarté sur ce qui doit être fait, n'hésitez pas à poser des questions dans les commentaires.

**J'ai trouvé une coquille, dois-je signaler un problème avant de pouvoir faire une _pull request_ ?**

Pour les fautes de frappe et autres changements de formulation, vous pouvez directement ouvrir une _pull request_ sans créer de ticket au préalable. Les `issues` servent généralement pour discuter de problèmes plus vastes liés aux codes ou aux aspects structurels du programme d'études.

**Je suis nouveau sur GitHub et l'Open Source en général :**

Lisez notre guide [Comment contribuer à l'Open Source](https://github.com/freeCodeCamp/how-to-contribute-to-open-source).

**Je suis coincé sur quelque chose qui n'est pas inclus dans cette documentation. Comment puis-je obtenir de l'aide ?**

N'hésitez pas à demander de l'aide :

- [La catégorie "Contributors" de notre forum public](https://www.freecodecamp.org/forum/c/contributors)
- [Nos contributeurs publics discutent sur un salon de chat Gitter](https://gitter.im/FreeCodeCamp/Contributors)

Nous sommes heureux de vous aider à contribuer à tous les sujets sur lesquels vous aimeriez travailler. N'hésitez pas à nous poser des questions sur les fils de discussion associés. Nous nous ferons un plaisir de vous fournir des éclaircissements. Assurez-vous de rechercher votre requête avant d'en poster une nouvelle. Soyez poli et patient. Notre communauté de bénévoles et de modérateurs est toujours là pour vous guider à travers vos questions.
