<!-- do not translate this -->
| [Read these guidelines in other languages](/docs/i18n-languages) |
|-|
<!-- do not translate this -->

# Le Linee guida per la contribuzione

Ciao 👋!

freeCodeCamp.org è possibile grazie a migliaia di volontari come te. Siamo grati per il tuo contributo e siamo lieti di accoglierti a bordo.

Applichiamo rigorosamente il nostro ["Codice di condotta"](https://www.freecodecamp.org/code-of-conduct). Prenditi un momento per leggerlo. È lungo solo 196 parole.

Ti auguriamo un felice contributo 🎉!

## Ecco alcuni modi divertenti in cui ci puoi aiutare

Puoi scegliere di contribuire a qualsiasi area che ti interessa:

1. [Contribuisci a questo codice open source.](#contribuisci-a-questo-codice-open-source). Aiuta a modificare gli [articoli guida](https://guide.freecodecamp.org/), [sfide di codifica](https://learn.freecodecamp.org/), o correggi i bug/errori sulla piattaforma di apprendimento.

2. Aiuta i colleghi sul nostro [forum pubblico](https://www.freecodecamp.org/forum/). [Rispondi alle loro domande di codifica](https://www.freecodecamp.org/forum/?max_posts=1) o [dai loro feedback sui loro progetti di codifica](https://www.freecodecamp.org/forum/c/project-feedback?max_posts=1)

3. Aiutaci ad aggiungere i sottotitoli ai nostri [video del canale YouTube](https://www.youtube.com/channel/UC8butISFwT-Wl7EV0hUK0BQ/videos).

## Contribuisci a questo codice open source

Abbiamo un enorme numero di codice open source nelle migliaia di [sfide di codifica](https://learn.freecodecamp.org) e [articoli guida](https://guide.freecodecamp.org).

Puoi aiutarci:

- [📝 Ricerca, scrivi e aggiorna i nostri articoli guida](#ricerca-scrivi-e-aggiorna-i-nostri-articoli-guida)


- [💻 Crea, aggiorna e correggi i bug nelle nostre sfide di codifica](#crea-aggiorna-e-correggi-i-bug-nelle-nostre-sfide-di-codifica)

- [🌐 Traduci gli articoli guida e le sfide di codifica](#traduci-gli-articoli-guida-e-le-sfide-di-codifica)

- [🛠 Aiutaci a correggere i bug nella piattaforma di apprendimento di freeCodeCamp.org](#aiutaci-a-correggere-i-bug-nella-piattaforma-di-apprendimento-di-freecodecamporg)

###  Ricerca, scrivi e aggiorna i nostri articoli guida

**Cosa sono gli articoli Guida?**

Gli articoli guida ti aiutano a comprendere rapidamente il concetto di tecnologia. Queste sono brevi spiegazioni in un italiano semplice che è possibile leggere prima di passare a risorse più approfondite.

Puoi trovare un [articolo di esempio sull'elemento Ancora HTML qui](https://github.com/freeCodeCamp/freeCodeCamp/blob/master/guide/english/html/elements/a-tag/index.md).

**Cosa posso scrivere in un articolo?**

Ogni tuo aiuto nello scrivere questi articoli è ben accolto. Non devi essere un esperto in un argomento per scriverne: questa intera guida è open source, quindi anche se commetti un errore, qualcun altro contribuirà per correggerlo.

Per aiutare, trova un articolo abbozzato ("stub") sul nostro [sito web di guida](https://www.freecodecamp.org/guide), scrivi l'articolo, quindi apri una pull request delle modifiche per sostituire la bozza con il tuo articolo. Una [pull request](https://help.github.com/articles/about-pull-requests/) è il modo in cui suggerirai le modifiche. Permette agli altri di conoscere le tue modifiche, rivederle e adottarle.

Se non riesci a trovare uno stub sull'argomento di cui vorresti scrivere, puoi aprire un PR che crea lo stub e include il tuo articolo di brutta copia.

Se vuoi contribuire a migliorare gli articoli guida, ecco [come lavorare sugli articoli guida](/docs/how-to-work-on-guide-articles.md).

### Crea, aggiorna e correggi i bug nelle nostre sfide di codifica

Tutte le nostre sfide di programmazione sono curate dalla comunità, portando la conoscenza di esperti da volontari come te.

Puoi aiutarli ad espanderli e rendere più chiara la loro formulazione. Puoi aggiornare le storie degli utenti per spiegare meglio il concetto e persino rimuovere quelli ridondanti/ripetitivi. È inoltre possibile migliorare i test di sfida per renderli più accurati dei test del codice degli altri.

Se sei interessato a migliorare queste sfide di programmazione, ecco [come lavorare sulle sfide di programmazione](/docs/how-to-work-on-coding-challenges.md).

### Traduci gli articoli guida e le sfide di programmazione

Puoi aiutarci a tradurre i nostri articoli guida e le sfide di programmazione per una lingua che parli. Attualmente abbiamo tradotto le versioni in:

- [Cinese (中文)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/chinese)
- [Russo (русский)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/russian)
- [Arabo (عربى)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/arabic)
- [Spagnolo (Español)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/spanish)
- [Portoghese (Português)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/portuguese)
- [Italiano (Italiano)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/italian)

Ci piacerebbe ricevere il tuo aiuto per migliorare la qualità di queste traduzioni. Milioni di persone usano la versione in lingua inglese di freeCodeCamp.org, e ci aspettiamo che altri milioni usino anche queste versioni tradotte.

### Aiutaci a correggere i bug nella piattaforma di apprendimento di freeCodeCamp.org

La nostra piattaforma di apprendimento funziona su un moderno stack JavaScript. Dispone di vari componenti, strumenti e librerie inclusi, tra l'altro però senza limitarsi, Node.js, MongoDB, LoopBack, OAuth 2.0, React, Gatsby, Webpack e altri.

In linea di massima,

- Abbiamo un server API basato su Node.js.
- Un set di applicazioni client basate su React.
- Uno script che usiamo per valutare i nostri progetti di Frontend.

Contribuire a questo richiede una certa comprensione delle API, ES6 Sintassi e molta curiosità.

In sostanza, ci aspettiamo una certa familiarità di base, con alcune delle tecnologie, strumenti e librerie sopra citate. Detto questo, non è necessario che tu sia un esperto riguardo a questi argomenti.

Sentiti libero di farci domande, nei relativi thread, e saremo lieti di chiarire. In caso di dubbio, puoi raggiungere Mrugesh Mohapatra [`@raisedadead`](https://github.com/raisedadead) o Stuart Taylor [`@bouncey`](https://github.com/bouncey) dalla nostra piattaforma dev team per aiutarti.

Se vuoi aiutarci a migliorare il nostro codebase, ecco [come installare freeCodeCamp localmente](/docs/how-to-setup-freecodecamp-locally.md).

## Domande frequenti

**Come posso segnalare un bug/errore, che non è sulla lavagna?**

Se pensi di aver trovato un bug/errore, leggi prima l'articolo ["Aiuto! Ho trovato un bug/errore"](https://forum.freecodecamp.org/t/how-to-report-a-bug/19543) e segui le sue istruzioni.

Se sei sicuro che sia un nuovo bug, vai avanti e crea un nuovo issue su GitHub. Assicurati di includere quante più informazioni possibili in modo che noi possiamo riprodurre il bug. Abbiamo un modello di problema predefinito per aiutarti con questo.

Si prega di notare che eventuali problemi che richiedono aiuto nella programmazione per una sfida saranno chiusi. Il tracker dei problemi è strettamente correlato ai problemi e alle discussioni relativi al codebase. Dovresti [cercare assistenza sul forum](https://www.freecodecamp.org/forum) prima di segnalare ogniqualvolta ci sono dubbi.

**Come posso segnalare un problema di sicurezza?**

Si prega di non creare issue su GitHub per problemi di sicurezza. Invece, si prega di inviare una mail a `security@freecodecamp.org` e lo esamineremo immediatamente.

**Mi sono bloccato su qualcosa che non è in questa documentazione. Come posso ottenere aiuto?**

Sentiti libero di chiedere aiuto su:

- [La categoria "Contributori" dell nostro forum pubblico](https://www.freecodecamp.org/forum/c/contributors)
- [La nostra chat room dei contributori pubblici su Gitter](https://gitter.im/FreeCodeCamp/Contributors)

Siamo lieti di aiutarti a contribuire a uno qualsiasi degli argomenti su cui vorresti lavorare. Assicurati di cercare la tua domanda prima di pubblicarne una nuova. Sii educato e paziente. I nostri volontari e moderatori della comunità sono sempre in giro per guidarti nelle tue domande.

**Sono nuovo su GitHub e nell'Open Source in generale:**

Leggi la nostra [Guida su come contribuire all'open source](https://github.com/freeCodeCamp/how-to-contribute-to-open-source).

**Che cosa significano le diverse etichette che sono taggate sui problemi?**

I nostri moderatori della comunita' [smistano](https://en.wikipedia.org/wiki/Software_bug#Bug_management) i problemi e le pull request in base alla loro priorità, gravità e altri fattori. Puoi [trovare qui un glossario completo dei loro significati](https://github.com/freecodecamp/freecodecamp/labels).

Dovresti esaminare gli argomenti **`Help Wanted`** oppure **`first timers welcome`** per una rapida ricerca di ciò che è disponibile e su cui puoi lavorare. Sono tutti problemi aperti e non c'è bisogno di chiedere il pemesso prima di lavorarci su.

Se questi problemi mancano di chiarezza su ciò che deve essere fatto, sentiti libero di porre domande nei commenti.

**Ho trovato un errore di battitura, dovrei segnalare un problema prima di poter effettuare una pull request?**

Per errori di battitura e altre variazioni di testo, è possibile aprire direttamente le pull request senza creare prima un issue. Gli issue sono utilizzati per discutere di problemi più grandi associati al codice, o di aspetti strutturali del curriculum.
