<!-- do not translate this -->
| [Read these guidelines in other languages](/docs/i18n-languages) |
|-|
<!-- do not translate this -->

# 기여 지침

안녕하세요. 👋

freeCodeCamp.org는 여러분과 같은 수천 명의 친절한 자원봉사자 덕분에 운영할 수 있습니다. 우리는 여러분의 기여를 환영하며 감사하고 기쁘게 생각합니다.

우리는 [행동 강령](https://www.freecodecamp.org/code-of-conduct)을 엄격히 시행하고 있습니다. 잠시 시간을 내어 읽어주세요. 196단어밖에 되지 않습니다.

행복한 기여가 되길 바랍니다.

## 기여할 수 있는 몇 가지 재미있는 방법들

여러분은 어느 방법으로도 기여할 수 있습니다.

1. [오픈소스 코드 베이스에 기여](#contribute-to-this-open-source-codebase)할 수 있습니다. 코딩 챌린지를 편집하거나 학습 플랫폼의 버그를 수정해 도움을 주세요.

2. [공개 포럼](https://www.freecodecamp.org/forum/)에서 학습자들을 도와주세요. [코딩 질문에 답변](https://www.freecodecamp.org/forum/?max_posts=1)해주거나 [코딩 프로젝트에 대한 피드백을 제공](https://www.freecodecamp.org/forum/c/project-feedback?max_posts=1)할 수 있습니다.

3. [유튜브 채널 비디오](https://www.youtube.com/channel/UC8butISFwT-Wl7EV0hUK0BQ/videos)에 자막 (숨겨진 캡션)을 추가할 수 있습니다.

## 오픈소스 코드 베이스에 기여하기

우리의 코드 베이스는 수천 개의 [코딩 챌린지](https://learn.freecodecamp.org)와 막대한 오픈소스 코드 베이스를 가지고 있습니다.

### 코딩 챌린지 만들기, 업데이트하기, 버그 수정하기

모든 코딩 챌린지는 커뮤니티가 엄선한 것이며, 여러분과 같은 자원봉사자들이 기여한 전문 지식입니다.

여러분은 코딩 챌린지에 자세한 설명을 덧붙이거나 명확한 표현으로 바꿀 수도 있습니다. 개념을 더 잘 설명하기 위해 유저 스토리를 업데이트 할 수도 있고 중복되는 내용을 삭제할 수도 있습니다. 또한 챌린지 테스트의 정확성을 높여 테스트를 개선할 수도 있습니다.

**이러한 코딩 챌린지를 개선하는 데 관심이 있으시다면, [코딩 챌린지 작업 방법](/docs/how-to-work-on-coding-challenges.md)를 참고해주세요.**

### freeCodeCamp.org 학습 플랫폼의 버그 수정하기

우리의 학습 플랫폼은 모던 자바스크립트 스택으로 운영됩니다. 플랫폼은 Node.js, MongoDB, LoopBack, OAuth 2.0, React, Gatsby, Webpack 외에도 다양한 컴포넌트, 도구, 라이브러리로 구성되어 있습니다.

간단히 말해, 이렇게 이루어져 있습니다.

- Node.js 기반 API 서버
- 일련의 React 기반 클라이언트 애플리케이션
- 프론트엔드 프로젝트를 평가하기 위해 사용하는 스크립트

이러한 학습 플랫폼에 기여하기 위해서는 API와 ES6 문법에 대한 이해와 많은 호기심이 필요합니다.

기본적으로 앞서 언급한 기술, 도구 및 라이브러리에 대한 기초 지식이 필요합니다. 말하자면, 여러분은 기여하기 위해 전문가가 될 필요가 없습니다.

**코드 베이스를 개선하는 데 도움을 주고 싶다면 [로컬에서 freeCodeCamp를 설치](/docs/how-to-setup-freecodecamp-locally.md)하거나 Gitpod이나 무료 온라인 개발 환경을 사용하면 됩니다.**

[![Open in Gitpod](https://gitpod.io/button/open-in-gitpod.svg)](https://gitpod.io/#https://github.com/freeCodeCamp/freeCodeCamp)

(여러분의 브라우저에서 freecodecamp의 개발 환경을 실행합니다.)

## 자주 묻는 질문

**새로운 버그를 어떻게 신고할 수 있나요?**

만약 새로운 버그를 발견했다고 생각한다면, 먼저 ["Help I've Found a Bug"](https://forum.freecodecamp.org/t/how-to-report-a-bug/19543) 문서를 읽고 지시를 따르세요.

새로운 버그라고 확신이 든다면, 먼저 새로운 GitHub 이슈를 만드세요. 우리가 그 버그를 재현할 수 있도록 가능한 많은 정보를 포함해야 한다는 것을 명심하세요. 이때 도움이 될 수 있도록 미리 이슈 템플릿을 만들어 놓았습니다.

코딩 챌린지에 대한 도움을 요청하는 이슈는 닫힌다는 점을 유의하세요. 이슈 트래커는 코드베이스 관련 이슈와 논의만을 위한 것입니다. 잘 모르겠다면, 보고를 하기 전에 [포럼에서 도움을 요청](https://www.freecodecamp.org/forum)하세요.

**보안 이슈를 어떻게 신고할 수 있나요?**

보안 이슈로 GitHub 이슈를 만들지 말아 주세요. 대신 `security@freecodecamp.org`로 이메일을 보내주시면 즉시 확인하겠습니다.

**이슈에 붙은 다양한 라벨은 무엇을 의미하나요?**

커뮤니티 중재자는 우선순위, 심각성 및 기타 요인에 따라 이슈를 [분류](https://en.wikipedia.org/wiki/Software_bug#Bug_management)하고 PR을 보냅니다. [여기서 모든 라벨의 의미를 찾아볼 수 있습니다](https://github.com/freecodecamp/freecodecamp/labels).

여러분이 작업할 수 있는 이슈를 빠르게 찾고 싶다면 [**`help wanted`**](https://github.com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22help+wanted%22) 또는 [**`first timers welcome`**](https://github.com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22first+timers+welcome%22) 라벨이 달린 이슈를 살펴보세요. 이 이슈들은 누구에게나 열려 있으며 작업하기 전에 허락을 구할 필요가 없습니다.

만약 이슈의 설명이 불명확하다면 코멘트 란에 자유롭게 질문하세요.

**오타를 찾았는데 PR을 보내기 전에 이슈를 만들어야 하나요?**

오타나 단어 표현 변경과 관련해서는 이슈를 만들 필요 없이 바로 PR을 보내면 됩니다. 이슈는 커리큘럼의 코드나 구조적인 측면과 관련된 더 큰 문제들을 논의하기 위함입니다.

**GitHub과 오픈소스가 처음이에요.**

[오픈소스 가이드에 기여하는 방법](https://github.com/freeCodeCamp/how-to-contribute-to-open-source)을 읽어 보세요.

**문서에 포함되지 않은 문제가 있다면 어떻게 도움을 받을 수 있나요?**

자유롭게 도움을 요청하세요.

- [공개 포럼의 "Contributors" 카테고리](https://www.freecodecamp.org/forum/c/contributors)
- [Gitter에 있는 컨트리뷰터들의 대화방](https://gitter.im/FreeCodeCamp/Contributors)

우리는 여러분이 관심 있는 분야에 기여할 수 있도록 도와드릴 수 있어 대단히 기쁩니다. 관련된 이슈 스레드에 자유롭게 질문하시면, 반갑게 설명해드리겠습니다. 다만 기존에 같은 질문이 있었는지 먼저 검색해주세요. 공손함과 인내심도 필요합니다. 자원봉사자와 중재자들로 이 커뮤니티는 여러분을 도와드리기 위해 항상 대기하고 있습니다.

궁금한 사항이 있다면, 플랫폼 개발팀에 연락을 주세요.

| Name            | GitHub | Twitter |
|:----------------|:-------|:--------|
| Mrugesh Mohapatra | [`@raisedadead`](https://github.com/raisedadead) | [`@raisedadead`](https://twitter.com/raisedadead)|
| Ahmad Abdolsaheb | [`@ahmadabdolsaheb`](https://github.com/ahmadabdolsaheb) | [`@Abdolsaheb`](https://twitter.com/Abdolsaheb) |
| Kristofer Koishigawa | [`@scissorsneedfoodtoo`](https://github.com/scissorsneedfoodtoo) | [`@kriskoishigawa`](https://twitter.com/kriskoishigawa) |

> **Email: `dev@freecodecamp.org`**
