<!-- do not translate this -->
| [Read these guidelines in other languages](/docs/i18n-languages) |
|-|
<!-- do not translate this -->

# Orientações para Contribuição

Olá 👋!

freeCodeCamp.org é possível graças a milhares de voluntários gentis como você. Somos gratos por suas contribuições e estamos felizes em te receber.

Nós seguimos as diretrizes do nosso ["Código de Conduta"](https://www.freecodecamp.org/code-of-conduct). Dedique um tempo para lê-lo. Ele não é muito longo.

Divirta-se contribuindo 🎉!

## Esses são alguns jeitos divertidos de contribuir

Você pode contribuir para qualquer área do seu interesse:

1. [Contribua para essa base de códigos abertos.](#contribua-para-essa-base-de-códigos-abertos)

    Nos ajude criando e editando [Artigos guia](https://www.freecodecamp.org/guide), [desafios de codificação](https://www.freecodecamp.org/learn), ou corrigindo bugs na plataforma de aprendizado.

2. Ajude campistas em nosso [fórum público](https://www.freecodecamp.org/forum/).

    - ❓ Ajude campistas [respondendo suas perguntas](https://www.freecodecamp.org/forum/?max_posts=1).
    - 💬 [Faça comentários](https://www.freecodecamp.org/forum/c/project-feedback?max_posts=1) em projetos dos campistas.

3. Nos ajude a legendar nosso [canal no YouTube](https://www.youtube.com/channel/UC8butISFwT-Wl7EV0hUK0BQ/videos).

## Contribua para essa base de códigos abertos

Nós temos uma base de código aberto gigantesca dos [Desafios de código](https://www.freecodecamp.org/learn) e [Artigos de guia](https://www.freecodecamp.org/guide).
Esses desafios e artigos compõem o conteúdo de aprendizado disponível na plataforma de aprendizado da freeCodeCamp.org.

Você pode nos ajudar:

- [📝 Pesquise, Escreva e Atualize nossos artigos de guia.](#pesquise-escreva-e-atualize-nossos-artigos-de-guia)

- [💻 Crie, Atualize e Corrija <i>Bugs</i> em nossos desafios de código.](#crie-atualize-e-corrija-bugs-em-nossos-desafios-de-código)

- [🌐 Traduza artigos de guia e desafios de código.](#traduza-artigos-de-guia-e-desafios-de-código)

- [🛠 Nos ajude a corrigir <i>bugs</i> na plataforma de aprendizado da freeCodeCamp.org.](#nos-ajude-a-corrigir-bugs-na-plataforma-de-aprendizado-da-freecodecamporg)

### Pesquise, Escreva e Atualize nossos artigos de guia

**O que são Artigos de guia?**

Artigos de guia ajudam você a ter um rápido entendimento sobre um conceito tecnológico. Eles são explicações em Português, curtas e diretas, que você pode ler antes de partir para recursos mais aprofundados.

Você pode encontrar um [artigo de exemplo sobre elementos HTML aqui](../../guide/portuguese/html/elements/index.md).

**Sobre o que eu posso escrever um artigo?**

Nós agradecemos sua ajuda na escrita desses artigos. Você não precisa ser um especialista em um tópico para escrever sobre isso - Todo o Guia é código aberto, então mesmo que você cometa um erro, outro contribuidor vai eventualmente corrigí-lo.

Para ajudar, encontre um `artigo provisório` na [página de Guias](https://www.freecodecamp.org/guide), escreva o artigo, e então abra um <i>pull request</i> (PR) para substituir o provisório pelo seu artigo. Um [<i>pull request</i>](https://help.github.com/articles/about-pull-requests/) é a forma como você vai sugerir mudanças. Ele permite que outros saibam das suas mudanças, revisem-nas e as adotem.

Se você não consegue encontrar um artigo provisório do tópico sobre o qual você gostaria de escrever, você pode abrir um PR que cria o artigo provisório e então incluir o rascunho do seu artigo.

**Se você gostaria de trabalhar nisso, por favor, siga as seguintes recomendações:**

#### [Como trabalhar em Artigos de guia.](/docs/i18n-languages/portuguese/how-to-work-on-guide-articles.md)

### Crie, Atualize e Corrija <i>Bugs</i> em nossos desafios de código

Todos os nossos Desafios de código tem curadoria da comunidade, trazendo conhecimento especializado de voluntários como você.
Entretanto, eles precisam ser constantemente refinados para melhor qualidade. Por exemplo, você pode querer atualizar suas instruções para melhorar seu palavreado. Você pode atualizar as histórias de usuário para explicar o conceito melhor ou mesmo evitar redundâncias. Você pode querer refatorar testes que não passam em códigos válidos das histórias de usuário.

**Se você gostaria de trabalhar nisso, por favor, siga as seguintes recomendações:**

#### [Como trabalhar em desafios de código.](/docs/i18n-languages/portuguese/how-to-work-on-coding-challenges.md)

### Traduza artigos de guia e desafios de código

Você pode nos ajudar a traduzir nossos Artigos de guia e Desafios de código para uma língua que você fala. Atualmente, nós temos versões traduzidas em:

- [Arabic (عربي)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/guide/arabic)
- [Chinese (中文)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/guide/chinese)
- [Portuguese (Português)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/guide/portuguese)
- [Russian (русский)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/guide/russian)
- [Spanish (Español)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/guide/spanish)

A maioria dessas versões são traduções de máquina. Nós vamos amar sua ajuda em melhorar a qualidade dessas traduções.

**Se você gostaria de trabalhar nisso, por favor, siga as seguintes recomendações:**

**[TODO]** Nós estamos no processo de atualizar os documentos para o fluxo de tradução. Siga [`#18313`](https://github.com/freeCodeCamp/freeCodeCamp/issues/18313) para acompanhar o progresso.

### Nos ajude a corrigir <i>bugs</i> na plataforma de aprendizado da freeCodeCamp.org

Nossa plataforma de aprendizado roda em uma <i>stack</i> moderna de Javascript. Ela contém vários componentes, ferramentas e bibliotecas, incluindo, mas não limitadas a: Node.js, MongoDB, LoopBack, OAuth 2.0, React, Gatsby, Webpack, entre outras.

De maneira geral,

- Nós temos um servidor de API baseado em Node.js.
- Um conjunto de aplicações cliente baseadas em React.
- Um <i>script</i> que nós utilizamos para avaliar nossos projetos <i>Frontend</i>.

Contribuir para isso requer certo conhecimento de APIs, sintaxe ES6 e bastante curiosidade.

Nós esperamos certa familiaridade básica com algumas das tecnologias, ferramentas e bibliotecas mencionadas. Dito isso, não é necessário que você seja um especialista nelas.

Sinta-se livre para nos fazer qualquer pergunta nos tópicos de questões relacionadas, e nós seremos gratos em explicar. Quando em dúvida, você pode contatar Mrugesh Mohapatra [`@raisedadead`](https://github.com/raisedadead) ou Stuart Taylor [`@bouncey`](https://github.com/bouncey) do nosso time de desenvolvimento da plataforma para o ajudar.

**Se você gostaria de trabalhar nisso, por favor, siga as seguintes recomendações:**

#### [Como configurar freeCodeCamp localmente.](/docs/i18n-languages/portuguese/how-to-setup-freecodecamp-locally.md)

## Perguntas Frequentes

**Como eu posso reportar um <i>bug</i>?**

Se você acha que encontrou um <i>bug</i>, primeiro leia o artigo ["Help I've Found a Bug"](https://forum.freecodecamp.org/t/how-to-report-a-bug/19543) e siga as instruções.

Se você está confiante de que se trata de um <i>bug</i> novo, vá em frente e crie uma nova <i>issue</i> no GitHub. Certifique-se de incluir o máximo de informações possível para que nós possamos reproduzir o <i>bug</i>. Nós temos um modelo pré definido para <i>issues</i> para ajudá-lo nisso.

Por favor, repare que qualquer <i>issue</i> que esteja buscando ajuda no código de algum desafio será fechada. O acompanhador de <i>issues</i> é restrito a problemas e discussões relacionadas à base de código. Você deve [buscar ajuda no fórum](https://www.freecodecamp.org/forum) antes de reportar sempre que estiver em dúvida.

**Como eu posso reportar um problema de segurança?**

Por favor não crie <i>issues</i> relacionadas à segurança no GitHub. Ao invés disso, por favor envie um email para `security@freecodecamp.org` e nós iremos analisar imediatamente.

**Estou parado em algo que não está nessa documentação. Como posso conseguir ajuda?**

Sinta-se livre para pedir ajuda:

- [Na categoria de "Contribuidores" (<i>Contributors</i>) em nosso fórum público](https://www.freecodecamp.org/forum/c/contributors).
- [Em nossa sala pública de <i>chat</i> de contribuidores no Gitter](https://gitter.im/FreeCodeCamp/Contributors).

Nós estamos empolgados em te ajudar a contribuir para qualquer tópico em que você queira trabalhar. Certifique-se de fazer uma busca antes de publicar um tópico novo. Seja educado e paciente. Os voluntários e moderadores da nossa comunidade estão sempre por perto para te ajudar em suas questões.

**Eu sou novo no GitHub e <i>Open Source</i> (Código Aberto) em geral:**

Leia nosso [Guia de como contribuir para <i>Open Source</i>](https://github.com/freeCodeCamp/how-to-contribute-to-open-source).

**O que esses rótulos diferentes marcados nas <i>issues</i> significam?**

Nossa comunidade de moderadores faz uma [triagem](https://en.wikipedia.org/wiki/Software_bug#Bug_management) das <i>issues</i> e <i>pull requests</i> baseada em suas prioridades, gravidade e outros fatores. Você pode [encontrar um glossário completo dos seus significados aqui](https://github.com/freecodecamp/freecodecamp/labels).

Você deveria passar pelas <i>issues</i> de **`Help Wanted`** (Ajuda necessária) ou **`first timers welcome`** (Iniciantes são bem vindos) para uma rápida consulta do que está livre para você trabalhar. Elas estão disponíveis e você não precisa de permissão para começar a trabalhar nelas.

Se essas <i>issues</i> possuem falta de clareza do que deve ser feito, sinta-se livre para tirar suas dúvidas nos comentários.

**Encontrei um erro de escrita, eu devo reportar antes de criar um <i>pull request</i>?**

Você pode criar diretamente um <i>pull request</i> sem ter de reportar uma <i>issue</i> em casos de erros de escrita ou pequenas mudanças de palavreado. <i>Issues</i> são ferramentas para buscar confirmação em mudanças que você gostaria de propor por meio de um <i>pull request</i>.
