<!-- do not translate this -->
| [Read these guidelines in other languages](/docs/i18n-languages) |
|-|
<!-- do not translate this -->

# Reguli privind contribuțiile

Salut 👋!

freeCodeCamp.org este posibil datorită miilor de voluntari binevoitori ca tine . Suntem recunoscători pentru contribuțiile voastre și suntem încântați să vă întâmpinăm la bord.

Aplicăm cu strictețe ["Codul nostru de conduită"](https://www.freecodecamp.org/code-of-conduct). Ia-ți un moment să îl citești. Sunt doar 196 de cuvinte de citit.

Iți urăm contribuție plăcută 🎉!

## Aici sunt câteva moduri plăcute în care ne poți ajuta

Poți alege să contribuiești în orice arie/domeniu care te interesează:

1. [Contribuiește la codul open source al aceastei pagine.](#contribute-to-this-open-source-codebase). Ajutâ la editarea [articolelor de orientare](https://guide.freecodecamp.org/), la [provocările de codare](https://learn.freecodecamp.org/) sau la corectarea erorilor de pe platforma de învățare.

2. Ajută-i pe colegii de pe [forumul public](https://www.freecodecamp.org/forum/). [Răspunde la întrebările lor de codare](https://www.freecodecamp.org/forum/?max_posts=1) sau [oferăle feedback cu privire la proiectele lor de codare](https://www.freecodecamp.org/forum/c/project-feedback?max_posts=1)

3. Ajută-ne să adăugăm subtitrări în [videoclipurile canalului YouTube](https://www.youtube.com/channel/UC8butISFwT-Wl7EV0hUK0BQ/videos).

## Contribuiește la codul open source al aceastei pagine

Avem o vastă bază de open source cu mii de [provocări de codare](https://learn.freecodecamp.org) și [articole de orientare](https://guide.freecodecamp.org).

Poți să ne ajuți în felul următor:

- [📝 Caută, Scrie și Actualizează Ghidul articolelor](#research-write-and-update-our-guide-articles)

- [💻 Crează, Actualizează și Corectează erorile în provocările noastre de codare](#create-update-and-fix-bugs-in-our-coding-challenges)

- [🌐 Tradu Ghidul articolelor și provocările de codare](#translate-guide-articles-and-coding-challenges)

- [🛠 Ajută-ne să Corectăm bug-urile în platforma de învățare a freeCodeCamp.org](#help-us-fix-bugs-in-freecodecamporgs-learning-platform)

### Caută, Scrie și Actualizează Ghidul articolelor

**Ce este ghidul articolelor?**

Ghidul articolelor te ajută să înțelegi rapid conceptul tehnologiei. Acestea sunt scurte explicații explicite în limba engleză pe care le poți citi înainte de a te deplasa la resurse mai aprofundate.

Poți găsi un [exemplu de articol despre elementele HTML aici](./client/src/pages/html/elements/index.md).

**Despre ce pot scrie într-un articol?**

Noi încurajăm ajutorul tău pentru a scrie aceste articole. Nu trebuie să fii un expert într-un subiect care să scrii despre el - întregul Ghid este open source, deci chiar dacă faci o greșeală, un alt contribuitor o va corecta în cele din urmă.

Pentru a-ți fi de ajutor, găsește un "articol stub/trunchi" pe site-ul [Ghidul website-ului nostru](https://www.freecodecamp.org/guide), scrie articolul, apoi deschide o solicitare de integrare a modificărilor tale pentru a înlocui stubul cu articolul tău. O [solicitare de integrare a modificărilor] (https://help.github.com/articles/about-pull-requests/) este modul în care vei sugera modificările. Permite altora să știe despre modificările tale, să le revizuiască și să le adopte.

Dacă nu poți găsi un articol stub/trunchi despre subiectul despee care dorești să scrii, poți deschide un PR care creează un stub și include schița articolul tău.

Dacă dorești să contribui la îmbunătățirea articolelor de orientare, iată [cum să lucrezi cu articole de ghid](/docs/how-to-work-on-guide-articles.md).

### Crează, Actualizează și Corectează erorile în provocările noastre de codare

Toate provocările de codare sunt întreținute de comunitate, aducând cunoștințe de specialitate de la voluntari ca tine.

Tu poți ajuta să le extinzi și să le clarifichezi formularea. Poți actualiza povestirile utilizatorilor pentru a explica mai bine conceptul și chiar a elimina pe cele care se repetă. De asemenea, poți îmbunătăți testele provocărilor pentru a le face mai corect când ceilalți testează codul.

Dacă ești interesat să îmbunătățești aceste provocări de codare, iată [cum să lucrezi la provocările de codare](/docs/how-to-work-on-coding-challenges.md).

### Tradu Ghidul articolelor și provocările de codare

Ne poți ajuta să traducem Ghidul articolelor noastre și provocările de Codare pentru o limbă pe care o vorbești. În prezent avem traduse versiuni în:

- [Chineză (中文)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/chinese)
- [Rusă (русский)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/russian)
- [Arabă (عربى)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/arabic)
- [Spaniolă (Español)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/spanish)
- [Portugheză (Português)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/portuguese)
- [Română (Română)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/romanian)

Ne face plăcere ajutorul tău în îmbunătățirea calității acestor traduceri. Milioane de oameni folosesc versiunea în limba engleză a freeCodeCamp.org și ne așteptăm ca alte milioane de utilizatori să folosească și aceste versiuni traduse.

### Ajută-ne să Corectăm bug-urile în platforma de învățare a freeCodeCamp.org

Platforma noastră de învățare rulează pe un stack JavaScript modern. Dispune de diverse componente, instrumente și biblioteci, incluzând dar fără a se limita la Node.js, MongoDB, LoopBack, OAuth 2.0, React, Gatsby, Webpack și multe altele.

In linii mari,

- Avem un server API bazat pe Node.js.
- Un set de aplicații client bazate pe React.
- Un script pe care îl folosim pentru a evalua proiectele noastre Frontend.

Contribuind la acest lucru este nevoie de o înțelegere a API-urilor, sintaxei ES6 și o mulțime de curiozitate.

În esență, ne așteptăm la o anumită familiaritate de bază, cu unele dintre tehnologiile, instrumentele și bibliotecile menționate mai sus. Acestea fiind spuse, nu ți se cere să fii un expert la ele.

Simte-te liber să ne pui întrebări, cu privire la subiectele legate de acest subiect, și vom fi bucuroși să clarificăm. Când ai dubii, poți contacta pe Mrugesh Mohapatra Mrugesh Mohapatra [`@raisedadead`](https://github.com/raisedadead) sau Stuart Taylor [`@bouncey`](https://github.com/bouncey) de pe platforma noastră dev echipa pentru a te ajuta în acest sens.

Dacă dorești să ne ajutați să îmbunătățim codul nostru, iată [cum să configurezi freeCodeCamp local](/docs/how-to-setup-freecodecamp-locally.md).


## Întrebări frecvente

**Cum pot raporta un bug/eroare de cod, care nu este la bord/tablă?**

Dacă crezi că ai găsit un bug, mai întâi citește articolul ["Ajutor am găsit un bug"](https://forum.freecodecamp.org/t/how-to-report-a-bug/19543) și urmărește instrucțiunile sale.

Dacă ești convins că este vorba despre un bug nou, continuă și crează o nouă problemă GitHub. Asigură-te că incluzi cât mai multe informații posibil pentru ca să putem reproduce eroarea. Avem un șablon predefinit pentru a te ajuta să faci acest lucru.

Te rugăm să reții că orice problemă care solicită ajutor pentru codiul provocarii, va fi închisă. Problema tracker-ului este strict pentru problemele și discuțiile legate de codul de basă. Ar trebui să [solicitezi asistență pe forum](https://www.freecodecamp.org/forum) înainte de a raporta ori de câte ori ai îndoieli.

**Cum pot raporta o problemă de securitate?**

Te rugăm să nu creezi probleme GitHub pentru probleme de securitate. În schimb, trimite un e-mail la adresa `security@freecodecamp.org`și o vom examina imediat.

**M-am impotmolit pe ceva ce nu se află în documentația respectivă. Cum pot obține ajutor?**

Nu ezita să ceri ajutor în:

- [Categoria "Colaboratori" a forumul nostru public](https://www.freecodecamp.org/forum/c/contributors)
- [Camera/room noastră de discuții publice pe Gitter](https://gitter.im/FreeCodeCamp/Contributors)

Suntem bucuroși să te ajutăm să contribuiești la oricare dintre subiectele la care dorești să lucrezi. Asigură-te că ai căutat intrebarea ta înainte de a posta una nouă. Fii politicos și răbdător. Voluntarii și moderatorii noștri din comunitate sunt în permanență în imprejurimi pentru a te călăuzi prin intrebările tale.

**Sunt nou în GitHub și în Open Source în general:**

Citește [Cum să contribui la Ghidul Open Source](https://github.com/freeCodeCamp/how-to-contribute-to-open-source).

**Ce înseamnă aceste etichete diferite, care sunt atașate/anexate pe probleme?**

Moderatorii noștri din comunitate [triază](https://en.wikipedia.org/wiki/Software_bug#Bug_management) problemele si solicitarile de integrare a modificărilor pe baza priorității lor, gravității lor și a altor factori. Poți găsi [un glosar complet al semnificațiilor lor aici](https://github.com/freecodecamp/freecodecamp/labels).

Ar trebui să treci prin intermediul paginilor cu probleme **`Help Wanted/Am nevoie de ajutor`**  sau **`first timers welcome/pagina incepatorilor`** pentru a căuta rapid ceea ce este disponibil pentru tine pentru a lucra. Acestea sunt susținute pentru a fi luate și nu trebuie să lucrați în altceva înainte de a lucra la acestea.

Dacă aceste aspecte nu prezintă clarificări cu privire la ceea ce trebuie făcut, nu ezita să pui întrebări în comentarii.

**Am găsit o greșeală de tipărire, ar trebui să raportez o problemă înainte de a putea face o solicitare de integrare a modificărilor?**

Pentru greșelile de tipărire și alte modificări de genul acesta, poți deschide direct solicitari de integrare a modificărilor fără a crea mai întâi o problemă. Problemele sunt mai mult pentru a discuta probleme asociate cu codul, sau mai multe aspecte structurale ale curriculumului.
