<!-- do not translate this -->
| [Read these guidelines in other languages](/docs/i18n-languages) |
|-|
<!-- do not translate this -->

# Рекомендации по внесению вклада в freeCodeCamp

Привет 👋!

freeCodeCamp.org возможен благодаря тысячам добровольцев, таких как Вы. Мы благодарим Вас за Ваш вклад и рады приветствовать Вас на борту.

Мы строго соблюдаем наш «Кодекс поведения»: ['Code of Conduct'](https://www.freecodecamp.org/code-of-conduct). Потратьте минутку, чтобы ознакомиться. Это не займет много времени.

Счастливого участия 🎉!

## Вот некоторые интересные способы, которыми вы можете помочь

Вы можете внести свой вклад в интересующую вас область:

1. [Внести вклад в этот открытый репозиторий.](#внести-свой-вклад-в-этот-open-source-проект)

   Помогите нам в создании или редактировании обучающих статей, задач по программированию или исправлении ошибок на нашей обучающей платформе.

2. Помощь новичкам с нашим [форумом](https://www.freecodecamp.org/forum/).

    - ❓ Помощь новичкам [отвечая на их вопросы](https://www.freecodecamp.org/forum/?max_posts=1).
    - 💬 [Написать отзыв](https://www.freecodecamp.org/forum/c/project-feedback?max_posts=1) на проекты новичков.

3. Помогите нам добавить субтитры на нашем [канале YouTube](https://www.youtube.com/channel/UC8butISFwT-Wl7EV0hUK0BQ/videos).


## Внести свой вклад в этот open source проект

У нас есть огромная база с открытым исходным кодом из тысяч [задач по программированию](https://www.freecodecamp.org/learn) и [обучающих статей](https://www.freecodecamp.org/guide). Эти задачи и статьи составляют учебный контент, доступный на платформе обучения freeCodeCamp.org.

Вы можете помочь нам:

- [📝 В исследовании, написании и обновлении статей нашего руководства.](#изучение-написание-и-обновление-статей-нашего-руководства)

- [💻 В создании, обновлении и исправлении ошибок в наших задачах по программированию.](#создание-обновление-и-исправление-ошибок-в-наших-задачах-на-кодирование)

- [🌐 В переводе обучающих статей и задач по программированию.](#перевод-статей-руководства-и-задач-на-кодирование)

- [🛠 В исправлении ошибок на обучающей платформе freeCodeCamp.org](#помогите-нам-исправить-ошибки-в-обучающей-платформе-freecodecamporg)

### Изучение, написание и обновление статей нашего руководства

**Что за обучающие статьи?**

Обучающие статьи помогут вам быстро понять технологические концепции. Это краткие и простые объяснения, которые вы можете прочитать, прежде чем перейти к более глубоким темам.

Пример [статьи о HTML](./client/src/pages/html/elements/index.md).

**О чем я могу написать статью?**


Мы рады Вашей помощи с написанием этих статей. Вам не обязательно быть экспертом в теме, чтобы писать об этом - все это Руководство является открытым исходным кодом, поэтому, даже если вы допустили ошибку, другой участник в конечном итоге исправит это.


Чтобы помочь, найдите "заглушку" на нашем [Сайте Руководства](https://www.freecodecamp.org/guide), напишите статью, затем создайте 'pull request', чтобы заменить заглушку своей статьей. [pull request](https://help.github.com/articles/about-pull-requests/) вот как Вы можете предложить изменения. Это позволяет другим узнать о ваших изменениях, просмотреть их и принять их.

Если вы не можете найти заглушку по теме, о которой хотите писать, вы можете открыть PR, который создает заглушку и включает черновик Вашей статьи.

** Если вы хотите работать над этим, следуйте этим рекомендациям: **

#### [Как работать над статьями руководства](/docs/how-to-work-on-guide-articles.md)

### Создание, обновление и исправление ошибок в наших задачах на кодирование

Все наши задачи на кодирование пишутся сообществом, принося экспертные знания таких добровольцев, как Вы.

Тем не менее, их необходимо постоянно совершенствовать по качеству. Например, вы можете обновить инструкции, чтобы исправить их [пустословие](https://en.oxforddictionaries.com/definition/verbiage) Вы можете дополнить user stories, чтобы лучше объяснить концепцию и даже удалить лишнее. Вы можете захотеть рефакторить тесты, которые не проходят с текущим кодом для user stories.

** Если вы хотите работать над этим, следуйте этим рекомендациям: **

#### [Как работать над задачами по кодингу](/docs/how-to-work-on-coding-challenges.md)

### Перевод статей руководства и задач на кодирование

Вы можете помочь нам с переводом наших статей и задач о кодировании для языка, на котором вы говорите. В настоящее время мы переводим версии в:

- Chinese (中文)
- Russian (русский)
- Arabic (عربي)
- Spanish (Español)
- Portuguese (Português)

Большинство из этих версий переведены машиной. Мы будем рады вашей помощи в улучшении качества этих переводов.

** Если вы хотите работать над этим, следуйте этим рекомендациям: **

**[TODO]** Мы находимся в процессе обновления документов для рабочего процесса перевода. Следите [`#18313`](https://github.com/freeCodeCamp/freeCodeCamp/issues/18313) за прогрессом.

### Помогите нам исправить ошибки в обучающей платформе freeCodeCamp.org

Наша обучающая платформа работает на современном стеке JavaScript. Он использует различные компоненты, инструменты и библиотеки, включая, но не ограничиваясь Node.js, MongoDB, LoopBack, OAuth 2.0, React, Gatsby, Webpack, и другие.

В общем смысле,

- У нас есть сервер с API на Node.js.
- Набор клиентских приложений на основе React.
- Скрипт, который мы используем для оценки проектов Frontend.

Для этого требуется некоторое понимание API, синтаксиса ES6 и много любопытства.

Мы ожидаем некоторых базовых знаний о некоторых из вышеупомянутых технологий, инструментов и библиотек. Тем не менее, вы не обязаны быть в этом экспертом.

Не стесняйтесь задавать нам вопросы, о связанных проблемах, и мы будем рады прояснить. Когда вы сомневаетесь, вы можете связаться с Mrugesh Mohapatra [`@raisedadead`](https://github.com/raisedadead) или Stuart Taylor [`@bouncey`](https://github.com/bouncey) из нашей команды разработчиков платформы, чтобы помочь вам разобраться.

** Если вы хотите работать над этим, следуйте этим рекомендациям: **

#### [Как настроить freeCodeCamp локально.](/docs/how-to-setup-freecodecamp-locally.md)

## Часто задаваемые вопросы

**Как я могу сообщить об ошибке, которой не в списке?**

Если вы считаете, что обнаружили ошибку, сначала прочитайте ['Помощь Я нашел ошибку'](https://forum.freecodecamp.org/t/how-to-report-a-bug/19543) статью и следуйте инструкциям.

Если вы уверены, что это новая ошибка, продолжайте и создайте новую проблему на GitHub. Обязательно укажите как можно больше информации, чтобы мы могли воспроизвести ошибку. У нас есть предопределенный шаблон, который поможет вам в этом.

Обратите внимание, что любые вопросы, требующие помощи по задачам на кодирование, будут закрыты. Отслеживание проблем строго связано с вопросами и обсуждениями, связанными с кодовой базой. Вам лучше [искать помощь на форуме](https://www.freecodecamp.org/forum) перед тем как сообщать о любых сомнениях.

**Как я могу сообщить о проблеме безопасности?**

Пожалуйста, не создавайте проблемы на GitHub для проблем безопасности. Вместо этого отправьте электронное письмо по адресу `security@freecodecamp.org` и мы незамедлительно рассмотрим его.

**Я застрял в том, чего нет в этой документации. Как получить помощь?**

Не стесняйтесь обращаться за помощью в:

- [Категория «Участники» на нашем форуме](https://www.freecodecamp.org/forum/c/contributors).
- [Наш чат в Gitter](https://gitter.im/FreeCodeCamp/Contributors).

Мы рады помочь вам внести свой вклад в любую из тем, над которыми вы хотели бы работать. Перед отправкой нового вопроса убедитесь, что его не сделал кто-то до вас. Будьте вежливы и терпеливы. Наши волонтеры и модераторы сообщества всегда рядом, чтобы ответить на ваши вопросы.

**Я новичок в GitHub и Open Source в целом:**

Читайте наше [Руководство о внесении вклада в проекты с открытым исходным кодом](https://github.com/freeCodeCamp/how-to-contribute-to-open-source).

**Что означают разные виды ярлыков, которыми отмечены проблемы?**

Наши модераторы сообщества [сортируют](https://en.wikipedia.org/wiki/Software_bug#Bug_management) проблемы и выбирают запросы в соответствии с их приоритетом, серьезности или других факторов. Вы можете [найти полный глоссарий значений здесь](https://github.com/freecodecamp/freecodecamp/labels).

Лучше всего искать ярлыки с названиями "Нужна помощь" (**`Help Wanted`**) или "Новички приветствуются" (**`first timers welcome`**) для быстрого поиска тех проблем, которым вы можете помочь. Они уже готовы к работе, и никакой дополнительной подготовки не требуется.

Если в этих вопросах не хватает ясности в понимании того, что нужно сделать, не стесняйтесь задавать вопросы в комментариях.

**Я нашел опечатку, должен ли я сообщить о проблеме, прежде чем я смогу сделать запрос на дополнение ('pull request')?**

Вы можете сразу создать pull request с исправлениями опечаток или небольшими изменениями в [пустословие](https://en.oxforddictionaries.com/definition/verbiage), не сообщая о каких-либо проблемах дополнительно. Трекер Проблем ('issue tracker') - это инструмент для поиска существующих проблем, исправление которых вы можете предложить посредством pull request.
