<!-- do not translate this -->
| [Read these guidelines in other languages](/docs/i18n-languages) |
|-|
<!-- do not translate this -->

# Pautas de Contribución

¡Hola 👋!

freeCodeCamp.org es posible gracias a miles de voluntarios amables como tú. Estamos muy agradecidos por tus contribuciones y nos complace darte la bienvenida a bordo.

Cumplimos estrictamente nuestro ["Código de conducta"](https://www.freecodecamp.org/code-of-conduct). Tómate un momento para leerlo. Sólo son 196 palabras.

¡Feliz contribución 🎉!

## Aquí hay algunas formas divertidas en las que puedes ayudar:

Puedes optar por contribuir a cualquier área de tu interés:

1. [Contribuir a esta base de código abierto](#contribuye-a-esta-base-de-código-abierto). Ayúdanos a editar desafíos de código, o corrige errores en la plataforma de aprendizaje.

2. Ayuda a los campistas en nuestro [foro público](https://www.freecodecamp.org/forum/). [Responde a sus preguntas de código](https://www.freecodecamp.org/forum/?max_posts=1) o [aporta comentarios a sus proyectos](https://www.freecodecamp.org/forum/c/project-feedback?max_posts=1).

3. Ayúdanos a agregar subtítulos a los vídeos de nuestro [canal de YouTube](https://www.youtube.com/channel/UC8butISFwT-Wl7EV0hUK0BQ/videos).

## Contribuye a esta base de código abierto

Tenemos una gran base de código con miles de [Desafíos de Código](https://www.freecodecamp.org/learn/) y otro código fuente que conforma nuestra plataforma de aprendizaje.

### Crea, actualiza y corrige errores en nuestros desafíos de programacion

Todos nuestros desafíos de código son seleccionados por la comunidad, reuniendo el conocimiento experto de voluntarios como tú.

Puedes ayudar a expandirlos y a mejorar sus enunciados. También puedes actualizar las historias de usuario para explicar mejor el concepto, o eliminar las redundantes y mejorar las pruebas de los desafíos para que evalúen el código de forma más precisa.

**Si estás interesado en mejorar estos desafíos de código, aquí está [cómo trabajar en los desafíos de programación](/how-to-work-on-coding-challenges.md).**

### Ayúdanos a corregir errores en la plataforma de aprendizaje de freeCodeCamp

Nuestra plataforma de aprendizaje se ejecuta sobre una moderna pila de JavaScript. Tiene varios componentes, herramientas y bibliotecas, incluyendo pero no limitándose a Node.js, MongoDB, LoopBack, OAuth 2.0, React, Gatsby, Webpack, y más.

A grandes rasgos,

- Tenemos un servidor API basado en Node.js.
- Un conjunto de aplicaciones cliente basadas en React.
- Un _script_ que usamos para evaluar nuestros proyectos de _front-end_.

Contribuir a esto requiere cierto conocimiento de APIs, sintaxis ES6, y mucha curiosidad.

Básicamente, esperamos una familiaridad básica con algunas de las tecnologías, herramientas y bibliotecas mencionadas. Dicho esto, no es necesario que seas un experto en ellas para contribuir.

**Si quieres ayudarnos a mejorar nuestro código, puedes [configurar freeCodeCamp localmente](/how-to-setup-freecodecamp-locally.md) o usar Gitpod, un entorno de desarrollo _online_ gratuito.**

[![Abrir en Gitpod](https://gitpod.io/button/open-in-gitpod.svg)](https://gitpod.io/#https://github.com/freeCodeCamp/freeCodeCamp)

(Inicia un entorno de desarrollo para freeCodeCamp preparado para trabajar en tu navegador.)

## Preguntas frecuentes

### ¿Dónde están los artígulos de Guía (guide.freecodecamp.org)? ¿Cómo puedo contribuir a ellos?

Ya no tendremos artículos generales de guía. En lugar de eso planeamos publicar estas guías como tutoriales seleccionados por el equipo editorial. Estos tutoriales podrán ser publicados por el equipo en las _Developer News_.

### ¿Puedo traducir el contenido de freeCodeCamp?

Tenemos la intención de tener el contenido disponible en más idiomas, ahora mismo no tenemos una planificación para ello.

Comenzaremos por tener el contenido disponible en Chino. Esto nos permitirá entender las particularidades y homogeneizar los flujos de trabajo del desarrollo. China es una de las regiones demográficas más grandes en cuanto a nuestra audiencia no inglesa. Es por tanto una candidata ideal para la internacionalización (i18n). Ahora mismo tenemos cientos de miles de usuarios usando una versión antigua de la plataforma.

Los siguientes idiomas serán el *Árabe, Español, Portugués y Ruso* sin un orden particular. Para el Portugués y el Español nos centraremos en América Latina como la región demográfica objetivo basado en la audiencia que tenemos.

Aunque puedes trabajar en las traducciones, no podemos lanzarlas hasta más adelante, sin contar con la versión china que está planeada inicialmente para lanzarse a principios de 2020.

**Podríamos** aceptar _pull requests_ (solo traducciones humanas de buena calidad), analizadas caso por caso.

### ¿Puedo traducir la documentación de la base de código de freeCodeCamp?

Te invitamos a traducir la documentación de la base de código de freeCodeCamp a cualquier idioma de tu elección y actualizar las guías traducidas hasta el momento.

### ¿Cómo puedo reportar un error que no está publicado?

Si crees que has encontrado un error, primero lee el artículo ["Ayuda, he encontrado un error"](https://forum.freecodecamp.org/t/how-to-report-a-bug/19543) y sigue las instrucciones.

Si estás seguro de que es un error nuevo, siga adelante y crea un nuevo problema o _Issue_ en GitHub. Asegúrate de incluir la mayor cantidad de información posible para que podamos reproducir el error.

Ten en cuenta que cualquier problema que se registre para resolver dudas sobre el código de un desafío se cerrará. El seguimiento de problemas es estrictamente para los temas y discusiones relacionadas con la base de código. Si tienes alguna duda, puedes [buscar ayuda en el foro](https://www.freecodecamp.org/forum) antes de reportar un problema.

### ¿Cómo puedo reportar un problema de seguridad?

Por favor, no crees _issues_ de GitHub para problemas de seguridad. En su lugar, envía un correo electrónico a `security@freecodecamp.org` y lo veremos de inmediato.

### ¿Qué significan las diferentes etiquetas que aparecen en los problemas?

Los moderadores de nuestra comunidad [evalúan](https://en.wikipedia.org/wiki/Software_bug#Bug_management) _issues_ y _pull requests_ y los clasifican según la prioridad, la gravedad y otros factores. Puedes [encontrar un glosario completo de sus significados aquí](https://github.com/freecodecamp/freecodecamp/labels).

Debes buscar los problemas con las etiquetas [**`help wanted`**](https://github.com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22help+wanted%22) o [**`first timers welcome`**](https://github.com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22first+timers+welcome%22) para localizar rápidamente lo que está disponible para que trabajes.

Estos están libres para todos y no necesitan permisos antes de trabajar en ellos. Si estos temas no dejan claro lo que se debe hacer no dudes en preguntar en los comentarios.

### Encontré un error tipográfico, ¿debo crear un _issue_ antes de poder hacer un _Pull Request_?

Para los errores tipográficos y otros cambios de redacción, puedes abrir directamente los pull request sin crear primero un _issue_. Los _issues_ son más bien para discutir problemas más grandes asociados con el código, o aspectos más estructurales del contenido.

### ¿Cómo me pueden asignar un problema o _issue_?

Normalmente no asignamos problemas a nadie excepto a colaboradores veteranos para evitar ausencias que dejen estos problemas sin resolver. En su lugar, nos adherimos a la siguiente política para ser justos con todo el mundo:

1. El primer _pull request_ para un _issue_ es el preferente para ser integrado.
2. En caso de múltiples _pull requests_ para el mismo problema, damos prioridad a la calidad del código del _PR_.
    - ¿Has incluido tests?
    - ¿Tuviste en cuenta todos los casos de uso?
    - ¿Te aseguraste de que todos los tests pasaran, y confirmaste que todo funcionaba localmente?
3. Finalmente, damos preferencia a _pull requests_ que siguen nuestras recomendaciones.
    - ¿Seguiste la lista de tareas para el _pull request_?
    - ¿Le has puesto un título significativo?

No necesitas permiso para _issues_ que estén marcados con `help wanted` o `first timers welcome` como se explicó anteriormente. Sigue las recomendaciones con cuidado y abre el _pull request_.

### Soy nuevo en GitHub y en Open Source en general

Lee nuestra [Guía de cómo contribuir al código abierto](https://github.com/freeCodeCamp/how-to-contribute-to-open-source/blob/master/README-ES.md).

### Estoy atascado en algo que no está en esta documentación. ¿Cómo puedo obtener ayuda?

No dudes en pedir ayuda en:

- [La categoría "Colaboradores" en nuestro foro público](https://www.freecodecamp.org/forum/c/contributors).
- [La sala de chat de nuestros colaboradores públicos en Gitter](https://gitter.im/FreeCodeCamp/Contributors).

Nos emociona ayudarte a contribuir con cualquiera de los temas en los que te gustaría trabajar. Te invitamos a hacernos preguntas en el hilo del problema, y estaremos encantados de aclarar cualquier cosa. Asegúrate de buscar tu consulta antes de publicar una nueva. Sé educado y paciente. Nuestros voluntarios y moderadores de la comunidad están siempre alrededor para guiarte a través de tus consultas.

Si tienes dudas, puedes contactar con nuestro equipo de desarrollo de plataforma para ayudarte con ello:

| Name            | GitHub | Twitter |
|:----------------|:-------|:--------|
| Mrugesh Mohapatra | [`@raisedadead`](https://github.com/raisedadead) | [`@raisedadead`](https://twitter.com/raisedadead)|
| Ahmad Abdolsaheb | [`@ahmadabdolsaheb`](https://github.com/ahmadabdolsaheb) | [`@Abdolsaheb`](https://twitter.com/Abdolsaheb) |
| Kristofer Koishigawa | [`@scissorsneedfoodtoo`](https://github.com/scissorsneedfoodtoo) | [`@kriskoishigawa`](https://twitter.com/kriskoishigawa) |

> **Email: `dev@freecodecamp.org`**