![freeCodeCamp.org Social Banner](https://s3.amazonaws.com/freecodecamp/wide-social-banner.png)

[![Pull Requests Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat)](http://makeapullrequest.com)
[![first-timers-only Friendly](https://img.shields.io/badge/first--timers--only-friendly-blue.svg)](http://www.firsttimersonly.com/)
[![Open Source Helpers](https://www.codetriage.com/freecodecamp/freecodecamp/badges/users.svg)](https://www.codetriage.com/freecodecamp/freecodecamp)
[![Setup Automated](https://img.shields.io/badge/setup-automated-blue?logo=gitpod)](https://gitpod.io/from-referrer/)

## Open-source база та курикулум freeCodeCamp.org

[freeCodeCamp.org](https://www.freecodecamp.org) - це дружня спільнота де ви можете навчитися програмувати безкоштовно. Веб-сайт підтримується [неприбутковою організацією 501(c)(3) nonprofit](https://donate.freecodecamp.org) з ціллю допомогти мільйонам зайнятих людей перевестися до тех. індустрії. Наша сапільнота вже допомогла більш ніж 10 000 людей знайти їх першу розробницьку роботу.

Наш курикулум з full-stack веб розробки повністю безкоштовний і розрахований на вільний темп виконання. Ми пропонуємо тисячі інтерактивних задач з програмування для розширення ваших навичок та вмінь.

## Зміст

* [Сертифікації](#сертифікації)
* [Навчальна платформа](#the-learning-platform)
* [Повідомлення про баги та помилки](#reporting-bugs-and-issues)
* [Повідомлення порушень безпеки](#reporting-security-issues)
* [Внесок](#contributing)
* [Статус Platform, Build, Deployment](#platform-build-and-deployment-status)
* [Ліцензія](#license)


### Cертифікації

freeCodeCamp.org пропонує декілька безкоштовних сертифікацій. Кожна з них потребує виконання 5 web-проектів та має сотні опціональних задач для підготовки до проектів. Проходження кожної з сертифікацій, за нашими розрахунками, у програміста початкового рівня займе близько 300 годин.

Кожен з цих 30 проектів в навчальній програмі freeCodeCamp.org має власні юзер-сторі та автоматизовані тести, вони допомагають вам нарощувати проект поступово і гарантує, що ви виконали всі юзер-сторі перед тим, як подати проект.

Ви можете скористатися цими тестовими наборами через [freeCodeCamp's CDN] (https://cdn.freecodecamp.org/testable-projects-fcc/v1/bundle.js). Це означає, що ви можете будувати ці проекти на веб-сайтах як CodePen та Glitch, або навіть в середовищі розробки локального комп'ютера.

Щойно ви отримаєте сертифікат, ви завжди матимете його. Ви завжди зможете створити на нього посилання на вашому LinkedIn або резюме. І коли ваші потенційні роботодавці або незалежні клієнти натискнуть на це посилання, вони побачать перевірену персоналізовану сертифікацію.

Єдиний виняток з цього буде при виявленні порушення нашої [Академічної політики чесності] (https://www.freecodecamp.org/academic-honesty). Коли ми визначаємо людей, що однозначно плагіатують (подаючи код чи проекти інших людей як власні без цитування), ми робимо те, що повинні робити усі суворі навчальні заклади - ми відкликаємо їх сертифікати та блокуємо цим людей.

Ось наші шість основних сертифікатів:

#### 1. Сертифікація з Responsive Web Дизайну

- [Основи HTML and HTML5](https://learn.freecodecamp.org/responsive-web-design/basic-html-and-html5)
- [Основи CSS](https://learn.freecodecamp.org/responsive-web-design/basic-css)
- [Прикладний Візуальний Дизайн](https://learn.freecodecamp.org/responsive-web-design/applied-visual-design)
- [Прикладна Доступність](https://learn.freecodecamp.org/responsive-web-design/applied-accessibility)
- [Принципи Responsive Web Дизайну](https://learn.freecodecamp.org/responsive-web-design/responsive-web-design-principles)
- [CSS Flexbox](https://learn.freecodecamp.org/responsive-web-design/css-flexbox)
- [CSS Grid](https://learn.freecodecamp.org/responsive-web-design/css-grid)
  <br />
  <br />
  **Projects**: Сторінка Нагороди, Форма Опитування, Цільова Сторінка Продукту, Сторінка Технічної Документації, Веб-Сторінка Особистого Портфоліо

#### 2. Сертифікація з алгоритмів та структур даних JavaScript

- [Basic JavaScript](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/basic-javascript)
- [ES6](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/es6)
- [Regular Expressions](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/regular-expressions)
- [Debugging](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/debugging)
- [Basic Data Structures](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/basic-data-structures)
- [Algorithm Scripting](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/basic-algorithm-scripting)
- [Object Oriented Programming](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/object-oriented-programming)
- [Functional Programming](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/functional-programming)
- [Intermediate Algorithm Scripting](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/intermediate-algorithm-scripting)
  <br />
  <br />
  **Projects**: Palindrome Checker, Roman Numeral Converter, Caesar's Cipher, Telephone Number Validator, Cash Register

#### 3. Front End Libraries Certification

- [Bootstrap](https://learn.freecodecamp.org/front-end-libraries/bootstrap)
- [jQuery](https://learn.freecodecamp.org/front-end-libraries/jquery)
- [Sass](https://learn.freecodecamp.org/front-end-libraries/sass)
- [React](https://learn.freecodecamp.org/front-end-libraries/react)
- [Redux](https://learn.freecodecamp.org/front-end-libraries/redux)
- [React and Redux](https://learn.freecodecamp.org/front-end-libraries/react-and-redux)
  <br />
  <br />
  **Projects**: Random Quote Machine, Markdown Previewer, Drum Machine, JavaScript Calculator, Pomodoro Clock

#### 4. Data Visualization Certification

- [Data Visualization with D3](https://learn.freecodecamp.org/data-visualization/data-visualization-with-d3)
- [JSON APIs and Ajax](https://learn.freecodecamp.org/data-visualization/json-apis-and-ajax)
  <br />
  <br />
  **Projects**: Bar Chart, Scatterplot Graph, Heat Map, Choropleth Map, Treemap Diagram

#### 5. APIs and Microservices Certification

- [Managing Packages with Npm](https://learn.freecodecamp.org/apis-and-microservices/managing-packages-with-npm)
- [Basic Node and Express](https://learn.freecodecamp.org/apis-and-microservices/basic-node-and-express)
- [MongoDB and Mongoose](https://learn.freecodecamp.org/apis-and-microservices/mongodb-and-mongoose)
  <br />
  <br />
  **Projects**: Timestamp Microservice, Request Header Parser, URL Shortener, Exercise Tracker, File Metadata Microservice

#### 6. Information Security and Quality Assurance Certification

- [Information Security with HelmetJS](https://learn.freecodecamp.org/information-security-and-quality-assurance/information-security-with-helmetjs)
- [Quality Assurance and Testing with Chai](https://learn.freecodecamp.org/information-security-and-quality-assurance/quality-assurance-and-testing-with-chai)
- [Advanced Node and Express](https://learn.freecodecamp.org/information-security-and-quality-assurance/advanced-node-and-express)
  <br />
  <br />
  **Projects**: Metric-Imperial Converter, Issue Tracker, Personal Library, Stock Price Checker, Anonymous Message Board

#### Full Stack Development Certification

Once you have earned all 6 of these certifications, you'll be able to claim your freeCodeCamp.org Full Stack Development Certification. This final distinction signifies that you’ve completed around 1,800 hours of coding with a wide range of web development tools.

#### Legacy Certifications

We also have 3 legacy certifications from our 2015 curriculum, which are still available. All of the required projects for these legacy certifications will remain available on freeCodeCamp.org.

- Legacy Front End Development Certification
- Legacy Data Visualization Certification
- Legacy Back End Development Certification

### The Learning Platform

This code is running live at [freeCodeCamp.org](https://www.freecodecamp.org).

Our community also has:

- A [forum](https://www.freecodecamp.org/forum) where you can usually get programming help or project feedback within hours.
- A [YouTube channel](https://youtube.com/freecodecamp) with free courses on Python, SQL, Android, and a wide variety of other technologies.
- A [podcast](https://podcast.freecodecamp.org/) with technology insights and inspiring stories from developers.
- A comprehensive [guide to thousands of programming topics](https://guide.freecodecamp.org/)
- A [Developer News](https://www.freecodecamp.org/news) publication, a free, open source, no-ads place to cross-post your blog articles.

> ### [Join our community here](https://www.freecodecamp.org/signin).

### Reporting Bugs and Issues

If you think you've found a bug, first read the [how to report a bug](https://www.freecodecamp.org/forum/t/how-to-report-a-bug/19543) article and follow its instructions.

If you're confident it's a new bug, and have confirmed that someone else is facing the same issue, go ahead and create a new GitHub issue. Be sure to include as much information as possible so we can reproduce the bug.

### Reporting Security Issues

If you think you have found a vulnerability, please report responsibly. Don't create GitHub issues for security issues. Instead, please send an email to `security@freecodecamp.org` and we'll look into it immediately.

### Contributing

> ### [Please follow these steps to contribute.](CONTRIBUTING.md)

### Platform, Build and Deployment Status

The general platform status for all our applications is available at [`status.freecodecamp.org`](https://status.freecodecamp.org). The build and deployment status for the code is available in [our DevOps Guide](/docs/devops.md).

### License

Copyright © 2019 freeCodeCamp.org

The content of this repository is bound by the following licenses:

- The computer software is licensed under the [BSD-3-Clause](LICENSE.md) license.
- The learning resources in the [`/curriculum`](/curriculum) directory including their subdirectories thereon are licensed under the [CC-BY-SA-4.0](/curriculum/LICENSE.md) license.
