<!-- do not translate this -->
| [Read these guidelines in other languages](/docs/i18n-languages) |
|-|
<!-- do not translate this -->

# Локальна настройка freeCodeCamp
 
Дотримуйтесь цих вказівок щодо отримання freeCodeCamp локально у вашій системі. Це дуже рекомендується, якщо ви хочете регулярно робити зміни.

Для деяких робочих процесів внеску, як, наприклад, попередній перегляд сторінок для керівництва або викликів кодування, налагодження та виправлення помилок у кодовій базі, потрібно, щоб у вас був локальний запуск freeCodeCamp.

## Розкладіть сховище на GitHub
['Forking'](https://help.github.com/articles/about-forks/) - це крок, де ви отримуєте власну копію головного сховища freeCodeCamp (a.k.a _repo_) на GitHub.

Це важливо, оскільки це дозволяє вам працювати над власною копією freeCodeCamp на GitHub або завантажувати (клонувати) ваше сховище для роботи на локальному рівні. Пізніше ви зможете подати запит на зміни, які потрібно перетягнути в основний сховище, із запиту на витяг.

> ** ProTip: **

> Головне сховище в `https://github.com/freeCodeCamp/freeCodeCamp` часто називають сховищем`upstream`.
> Ваша вилка на `https://github.com/YOUR_USER_NAME/freeCodeCamp` часто називається сховищем`origin`.

#### Виконайте ці кроки, щоб розблокувати сховище `https://github.com/freeCodeCamp/freeCodeCamp`:
1. Перейдіть у сховище freeCodeCamp на GitHub: <https://github.com/freeCodeCamp/freeCodeCamp>
2. Клацніть кнопку "Fork" у верхньому правому куті інтерфейсу ([Детальніше тут](https://help.github.com/articles/fork-a-repo/))
3. Після розблокування репозиторію вас перейдуть до вашої копії сховища freeCodeCamp за адресою `https: // github.com / YOUR_USER_NAME / freeCodeCamp`

! [GIF - Як розкрутити freeCodeCamp на GitHub] (/docs/images/github/how-to fork-freeCodeCamp.gif)

## Підготовка середовища розробки
Після встановлення передумов вам потрібно підготувати середовище розробки. Це характерно для багатьох робочих процесів розвитку, і вам потрібно буде це зробити лише один раз.

#### Виконайте такі кроки, щоб підготувати ваше середовище розробки:
1. Установіть [Git](https://git-scm.com/) або ваш улюблений клієнт Git, якщо ви ще цього не зробили. Оновлення до останньої версії; версія, яка постачається в комплекті з вашою ОС, може бути застарілою.

2. (Необов’язково, але рекомендується) [Установка SSH ключа](https://help.github.com/articles/generating-an-ssh-key/) для GitHub.

3. Встановіть редактор коду на ваш вибір.

    Ми настійно рекомендуємо використовувати [VS Code](https://code.visualstudio.com/) або [Atom](https://atom.io/). Це чудові, безкоштовні та відкриті редактори кодів.

4. Налаштуйте підшивку для редактора коду.

    У вас повинен бути [ESLint запущений у вашому редакторі](http://eslint.org/docs/user-guide/integrations.html), і він виділить все, що не відповідає [FreeCodeCamp's JavaScript Guide Guide](http://forum.freecodecamp.org/t/free-code-camp-javascript-style-guide/19121).

    > Будь ласка, не ігноруйте жодних помилок зв’язування. Вони покликані **допомогти** та забезпечити чисту та просту базу коду.

## Клоніруйте свою копію freeCodeCamp
["Клонування"](https://help.github.com/articles/cloning-a-repository/) - це те, де ви ** завантажуєте ** копію сховища з "віддаленого" місця, яке вам належить. або кимось іншим. У вашому випадку це віддалене місце розташування - це "вилка" сховища freeCodeCamp, яке повинно бути доступне за адресою `https://github.com/YOUR_USER_NAME/freeCodeCamp`.

Запустіть ці команди на локальній машині:

1. Відкрийте Terminal/Command Prompt/Shell в каталозі своїх проектів

    _i.e ​​.: `/yourprojectsdirectory/` _

2. Клонуйте розгалуження freeCodeCamp, замінивши "YOUR_USER_NAME" на ваше ім'я користувача GitHub

    ``
    git clone --depth = 1
    ``

Це завантажить весь сховище freeCodeCamp у каталог ваших проектів.

Примітка: `--depth = 1` створює дрібний клон вашої вилки з лише останньою історією / фіксацією.

## Встановіть `upstream 'до основного сховища
Тепер, коли ви завантажили копію виделки, вам потрібно буде встановити "вгору".

Як вже згадувалося раніше, головне сховище в `https://github.com/freeCodeCamp/freeCodeCamp` часто називають сховищем` upstream`. Ваша роздiлка в `https://github.com/YOUR_USER_NAME/freeCodeCamp` часто називається сховищем" origin ".

Вам потрібна довідка з вашого локального клону на сховище `upstream 'на додаток до сховища` origin'. Це так, що ви можете синхронізувати зміни з основного сховища, не вимагаючи повторного розгортання та клонування.

1. Змініть каталог на новий каталог freeCodeCamp:

    ``
    cd freeCodeCamp
    ``

2. Додайте віддалену посилання на основне сховище freeCodeCamp:

    ``
    git remote add upstream https://github.com/freeCodeCamp/freeCodeCamp.git
    ``

3. Переконайтесь, що конфігурація виглядає правильно:

    ``
    git remote -v
    ``

    Вихід повинен виглядати приблизно так:

    ``
    origin    https://github.com/YOUR_USER_NAME/freeCodeCamp.git (fetch)
    origin    https://github.com/YOUR_USER_NAME/freeCodeCamp.git (push)
    upstream    https://github.com/freeCodeCamp/freeCodeCamp.git (fetch)
    upstream    https://github.com/freeCodeCamp/freeCodeCamp.git (push)
    ``

## Запуск freeCodeCamp локально на вашій машині
Тепер, коли у вас є локальна копія freeCodeCamp, ви можете слідувати цим інструкціям для запуску локально. Це дозволить вам:

- Попередній перегляд змін на сторінках, як вони з'являться на навчальній платформі.
- Робота над питаннями та вдосконаленнями інтерфейсу користувача
- Налагодження та усунення проблем із серверами прикладних програм та клієнтськими програмами.

Ви можете пропустити запуску freeCodeCamp локально, якщо ви просто редагуєте файли, виконуючи `rebase` або вирішуючи конфлікти` merge`. Ви завжди можете повернутися до цієї частини інструкцій пізніше.

[Пропустити запуск freeCodeCamp локально] (# внесення змін-до-вашого-клону-до-freecodecamp-локально)

В даний час існує два способи локального запуску freeCodeCamp:
- Doker (рекомендовано)
- Lokal

Вам потрібно дотримуватися будь-якого ** одного ** з перерахованих вище способів.

Установка Docker в ідеалі призведе до меншої кількості помилок під час встановлення і має на меті мати найкращий досвід розробника. Ми використовуємо Docker для встановлення та запуску додаткових програмних залежностей за кадром. Це має забезпечити безпроблемний та постійний досвід роботи на більшості типів пристроїв / ОС.

Якщо у вас виникли проблеми з використанням одного методу, спробуйте скористатися іншим. Якщо у вас виникли проблеми з будь-яким методом, спершу проведіть веб-пошук своєї проблеми та перевірте, чи на неї вже відповіли. Якщо ви не можете знайти рішення, перегляньте нашу сторінку GitHub [проблеми](https://github.com/freeCodeCamp/freeCodeCamp/isissue) для вирішення проблеми та повідомте про проблему, якщо вона ще не була повідомлена.

І, як завжди, не соромтеся зайти в наш [Чат для учасників](https://gitter.im/FreeCodeCamp/Contributors) для швидких запитів.

### Встановлення передумов
Почніть з установки необхідного програмного забезпечення:

Програмне забезпечення, необхідне для Docker і Local build:

| Необхідна умова | Версія | Примітки |
| ------------ | ------- | ----- |
| [Node.js](http://nodejs.org) | `10.x` | [LTS-графік] (https://github.com/nodejs/Release#release-schedule) |
| npm (постачається в комплекті з Node) | `6.x` | Не має випусків LTS, ми використовуємо версію в комплекті з Node LTS |

** Документ побудувати додаткову умову: **

| Необхідна умова | Версія | Примітки |
| ------------ | ------- | ----- |
| [Docker CE](https://docs.docker.com/install/) | `Stable` | - |
| [Docker Compose](https://docs.docker.com/compose/install/) | `Stable` | Потрібно встановити окремо, якщо не використовується macOS або Windows |

** Місцева додаткова умова: **

| Необхідна умова | Версія | Примітки |
| ------------ | ------- | ----- |
| [Сервер спільноти MongoDB](https://docs.mongodb.com/manual/administration/install-community/)| `3.6` |[Примітки до випуску](https://docs.mongodb.com/manual/release-notes/), Примітка. Зараз ми перебуваємо на `3.6`, планується оновлення[https://github.com/freeCodeCamp/ freeCodeCamp / issues / 18275). |

#### Важливо:
Ми настійно рекомендуємо оновити до останніх стабільних версій програмного забезпечення, перерахованого вище, також відомого як версії Long Term Support (LTS).
Якщо Node.js вже встановлений на вашій машині, виконайте такі команди, щоб перевірити версії:

`` sh
node -v
npm -v
`` `

Якщо у вас інша версія, встановіть рекомендовану версію. Ми можемо підтримувати проблеми встановлення лише для рекомендованих версій.

Користувачі Windows:
> Переконайтеся, що інструмент командного рядка, який ви використовуєте (наприклад, cmd, PowerShell, Git Bash для Windows, WSL), має правильні права користувача. Якщо можливо, слід запустити інструмент з привілеєм адміністратора. У Windows вам слід мати змогу запуститись як адміністратор, клацнувши правою кнопкою миші програму та вибравши "Запустити як адміністратор".

#### У мене виникають проблеми з установкою рекомендованих передумов. Що я повинен зробити?
Ми регулярно розробляємо новітні або найпопулярніші операційні системи, такі як macOS 10.12 або новішої версії, Ubuntu 16.04 або новішої версії та Windows 10. Рекомендуємо досліджувати вашу конкретну проблему на таких ресурсах, як Google, Stack Overflow та Stack Exchange. Є хороший шанс, що хтось стикався з тим же питанням, і вже є відповідь на ваш конкретний запит.

Якщо ви перебуваєте в іншій ОС та / або все ще стикаєтеся з проблемами, зверніться до [спільноти дописувачів на нашому громадському форумі] (https://www.freeCodeCamp.org/forum/c/contributors) або до [чату дописувача кімната](https://gitter.im/freeCodeCamp/Contributors).

** Будь ласка, уникайте створення випусків GitHub для попередніх проблем. Вони виходять за межі цього проекту **.

### Налаштування залежностей

#### Крок 1: Налаштування файлу змінної середовища
Клавіші API та змінні середовища за замовчуванням зберігаються у файлі `sample.env`. Цей файл потрібно скопіювати у новий файл під назвою `.env`, до якого динамічно звертається під час кроку встановлення.

``
# Створіть копію "sample.env" та назвіть її ".env".
# Заселіть його необхідними ключами та секретами API:

# macOS / Linux
cp sample.env .env

# Windows
copy sample.env .env
`` `

Клавіші у файлі `.env` * не * потрібно змінювати, щоб локально запускати додаток. Ви можете залишити значення за замовчуванням, скопійовані з `sample.env` як є.

Майте на увазі, якщо ви хочете скористатися додатковими послугами, вам доведеться придбати власні ключі API для цих служб і відповідно відредагувати записи у файлі `.env`.

** Створення збірки Docker: ** Якщо за допомогою збірки Docker і установки Docker доручили використовувати Docker Toolbox (стосується старих версій macOS і Windows), вам потрібно змінити `DOCKER_HOST_LOCATION` у вашому файлі` .env` вихід з команди `docker-machine ip`. Якщо ви використовуєте будь-який Docker, що підтримує аромат Linux, або ви використовуєте Docker Desktop (нові версії macOS та Windows 10), ви можете залишити `DOCKER_HOST_LOCATION` за замовчуванням.

#### Крок 2: Встановлення залежностей

Цей крок встановить залежності, необхідні для запуску програми:

** Створення докера: **
``
npm run docker: init
npm run docker: install
npm run docker: seed
``

Кожна з команд Docker, наведених вище, потребує певного часу. Вам слід дочекатися, коли кожна команда буде повністю виконана, перш ніж виконувати наступну.

Вам також потрібно буде встановити кілька пакетів в хвилину за межами Docker. Цей крок можна пропустити, якщо ви лише запускаєте додаток локально і не використовуєте git.
```shell
npm ci
```

Все вищезазначене потрібно запустити лише при першому налаштуванні локального середовища розробників.

** Місцевий збір: **

``
# Встановити залежності NPM
npm ci
``

#### Крок 3: Запустіть MongoDB і заведіть базу даних (лише для локальної збірки)

Цей крок стосується лише локальної збірки; якщо ви використовуєте збірку Docker, перейдіть до кроку 4.

Якщо у вас MongoDB не працює у налаштуваннях, відмінних від за замовчуванням, URL-адреса, збережена як значення "MONGOHQ_URL" у файлі `.env`, повинна працювати нормально. Якщо ви використовуєте власну конфігурацію, змініть це значення за потребою.

Перш ніж запустити програму локально, вам потрібно буде запустити послугу MongoDB:

Запустіть сервер MongoDB в окремому терміналі:
- На macOS та Ubuntu:

    `` sh
    mongod
    `` `

- У Windows потрібно вказати повний шлях до бінарного файлу `mongod`

    ``
    "C:\Program files\MongoDB\Server\3.6\bin\mongod"
    ``

    Не забудьте замінити `3.6` на встановлену вами версію

> ProTip:
> Ви можете уникнути необхідності запускати MongoDB кожен раз, встановлюючи його як фоновий сервіс.
> Ви можете [дізнатися більше про це в їх документації для вашої ОС](https://docs.mongodb.com/manual/administration/install-community/)

Далі давайте насіння в базу даних. На цьому кроці ми виконуємо команду нижче, яка заповнює сервер MongoDB деякими початковими наборами даних, необхідними службами. Сюди входять, серед іншого, кілька схем.

``
npm запуск насіння
``

#### Крок 4: Запустіть клієнтську програму freeCodeCamp та сервер API
Тепер ви можете запустити сервер API та клієнтські програми.

** Створення докера: **
``
npm run docker:develop
``

** Місцевий збір: **
``
npm run develop
``

Ця команда запустить усі сервіси, включаючи сервер API та клієнтські програми, доступні для роботи.

Після готовності відкрийте веб-браузер і відвідайте <http: // localhost: 8000>. Якщо додаток завантажується, вітаємо - ви все готові!

> ProTip:
> Сервер API обслуговує API на `http: // localhost: 3000 '
> Додаток Гетсбі обслуговує клієнтську програму за адресою `http: // localhost: 8000`

Якщо ви відвідаєте <http: // localhost: 3000 / explorer>, ви повинні побачити доступні API.

Вітаємо 🎉🎉🎉! Тепер у вас є копія всієї навчальної платформи freeCodeCamp на вашій локальній машині.

## Як увійти під час роботи локально
Ваша локальна установка автоматично заповнює локального користувача в базі даних. Натиснувши кнопку `Увійти`, ви автоматично підтвердите автентифікацію в локальній програмі.

Однак доступ до сторінки портфоліо користувачів є дещо складним. У процесі розвитку Gatsby бере на себе обслуговування сторінок на стороні клієнта, отже, ви отримаєте сторінку "404" для портфоліо користувачів під час роботи на місцях.

Якщо просто натиснути кнопку "Попередній перегляд користувальницької сторінки 404", ви перейдете на правильну сторінку.

! [Зображення - як увійти під час роботи локально](https://user-images.githubusercontent.com/1884376/52650951-48922e80-2f11-11e9-9eee-360a25ad28ad.gif)

## Швидкі посилання на команди при локальній роботі

Швидке посилання на команди, які знадобляться при локальній роботі.

** Створення докера: **

> ### Todo: Додайте швидкий список команд докер

** Місцевий збір: **

| команда | опис |
| ------- | ----------- |
| `npm ci` | Встановлює / перевстановлює всі залежності та завантажує різні служби. |
| `npm run seed` | Розбирає всі файли розмітки викликів і вставляє їх у MongoDB. |
| `npm run create` | Запускає сервер API FreeCodeCamp і клієнтські програми. |
| `npm test` | Запустіть усі тести JS в системі, включаючи клієнтські, серверні, тестові та випробувальні роботи. |
| `npm run test: client` | Запустіть клієнтський тестовий набір. |
| `npm run test: curriculum` | Запустіть тестовий набір навчальних програм. |
| `npm run test: server` | Запустіть тестовий набір сервера. |
| `npm run clean` | Видаляє всі залежності та очищує кеші. |

## Внесення змін у ваш клон FreeCodeCamp локально
Тепер ви можете вносити зміни до файлів і вносити свої зміни до локального клону своєї вилки.

Виконайте такі дії:

1. Перевірте, що ви перебуваєте на гілці `master`

    ``
    git status
    ``

    Ви повинні отримати такий результат:

    ``
    On branch master
    Your branch is up-to-date with 'origin/master'.

    нічого не робити, робочий каталог чистий
    ``

    Якщо ви не є майстром або ваш робочий каталог не є чистим, вирішіть всі непогашені файли / комісії та оформити замовлення `master ':

    ``
    git checkout master
    ``

2. Синхронізуйте останні зміни з гілки freeCodeCamp висхідної `master` гілки до локальної гілки master

    ** Примітка. ** Якщо у вас є якийсь непогашений запит на витяг, який ви зробили з `master` гілки вашої вилки, ви втратите їх в кінці цього кроку. Перед виконанням цього кроку ви повинні переконатися, що ваш запит на притягнення об'єднаний модератором. Щоб уникнути цього сценарію, слід * завжди * працювати над гілкою, окремо від головного.

    Цей крок ** синхронізує останні зміни ** з головного сховища freeCodeCamp. Важливо, щоб ви переобладнували свою філію на останній "upstream / master" якомога частіше, щоб пізніше уникнути конфліктів.

    Оновіть локальну копію сховища freeCodeCamp висхідного потоку:
    ``
    git fetch upstream stream
    ``

    Жорсткий скидання вашого головного відділення за допомогою майстра freeCodeCamp:

    ``
    git reset --hard upstream/master
    ``

    Перемістіть свою головну гілку до свого походження, щоб мати чисту історію на вилці на GitHub:

    ``
    git push origin master --force
    ``

    Ви можете перевірити, чи ваш поточний головний збір відповідає висхідному / головному, виконавши diff:

    ``
    git diff upstream/master
    ``

    Отриманий результат повинен бути порожнім.

3. Створіть нову гілку

    Робота над окремим відділенням для кожного випуску допоможе вам зберегти чисту копію місцевої роботи. Ніколи не слід працювати над "майстром". Це забруднить вашу копію freeCodeCamp, і вам, можливо, доведеться почати спочатку зі свіжим клоном або виделкою.

    Перевірте, чи перебуваєте ви на "master", як було пояснено раніше, і відключіться звідти:

    ``
    git checkout -b fix/update-guide-for-xyz
    ``

    Назва вашої філії має починатися з `fix/`, `feat/`, `docs/` тощо. Уникайте використання номерів випусків у гілках. Зберігайте їх короткими, змістовними та унікальними.

    Деякі приклади добрих назв гілок:

    ``
    fix/update-challenges-for-react
    fix/update-guide-for-html-css
    fix/platform-bug-sign-in-issues
    feat/add-guide-article-for-javascript
    translate/add-spanish-basic-html
    ``

4. Редагуйте сторінки та працюйте над кодом у вашому улюбленому текстовому редакторі

5. Після того, як ви задоволені змінами, необов'язково запускайте локально freeCodeCamp для попереднього перегляду змін

6. Переконайтеся, що ви виправили будь-які помилки та перевірте форматування змін. У розділі [docs](/docs/) для статей керівництва та проблем кодування у нас є посібники зі стилів

7. Перевірте і підтвердьте файли, які ви оновлюєте

    ``
    git статус
    ``

    Тут має відображатися перелік редакторів, які ви редагували нестандартними.

    ``
    Про галузевий подвиг/документацію
    Ваша філія є в курсі "upstream/feat/docs".

    Зміни, які не ставлять для комісії:
    (використовуйте "git add / rm <file> ...", щоб оновити те, що буде зроблено)
    (використовуйте "git checkout - <file> ...", щоб скасувати зміни в робочому каталозі)

        fix/update-challenges-for-react
        fix/update-guide-for-html-css
        fix/platform-bug-sign-in-issues
        feat/add-guide-article-for-javascript
        translate/add-spanish-basic-html
    ...
    ``

8. Поетапно зміни і візьміть на себе зобов’язання

    На цьому кроці слід позначити лише ті файли, які ви самі редагували чи додавали. Ви можете виконати скидання та усунення файлів, які ви не мали наміру змінювати, якщо це потрібно.

    ``
    git add path/to/my/changed/file.ext
    ``

    Або ви можете додати всі нестандартні файли до області постановки:

    ``
    git add.
    ``

    Тільки файли, які були переміщені в область постановки, будуть додані під час здійснення зобов’язання.

    ``
    git status
    ``

    Вихід:
    ``
    Про feat/documentation
    Ваша філія є в курсі "upstream/feat/documentation".

    Внесення змін:
    (використовуйте "git reset HEAD <file> ..." до нестабільності)

        modified:   CONTRIBUTING.md
        modified:   docs/README.md
        modified:   docs/how-to-setup-freecodecamp-locally.md
        modified:   docs/how-to-work-on-guide-articles.md
    ``

    Тепер ви можете здійснити свої зміни за допомогою короткого повідомлення:

    ``
    git commit -m "виправити: моє коротке повідомлення про здійснення"
    ``

    Деякі приклади:

    ``
    виправити: оновити статтю керівництва для Java - для циклу
    подвиг: додайте посібник для навичок alexa
    ``

    Необов’язково:

    Ми настійно рекомендуємо скласти звичайне повідомлення про фіксацію. Це хороша практика, яку ви побачите в деяких популярних сховищах з відкритим кодом. Як розробник, це спонукає вас дотримуватися стандартних практик.

    Деякі приклади звичайних повідомлень про фіксацію:

    ``
    fix: update HTML guide article
    fix: update build scripts for Travis-CI
    feat: add article for JavaScript hoisting
    docs: update contributing guidelines
    ``

    Зберігайте ці короткі, не більше 50 символів. Ви завжди можете додати додаткову інформацію в опис повідомлення про фіксацію.

    Це не займе додаткового часу, ніж нетрадиційне повідомлення типу "оновити файл" або "додати індекс.md"

    Ви можете дізнатися більше про те, чому слід використовувати звичайні коміти [тут](https://www.conventionalcommits.org/en/v1.0.0-beta.2/#why-use-conventional-commissions).

9. Якщо ви усвідомлюєте, що вам потрібно відредагувати файл або оновити повідомлення про фіксацію після здійснення зобов’язання, ви можете зробити це після редагування файлів за допомогою:

    ``
    git commit --amend
    ``

    Це відкриє текстовий редактор за замовчуванням, наприклад `nano` або` vi`, де ви можете редагувати заголовок повідомлення про фіксацію та додавати / редагувати опис.

10. Далі ви можете натиснути свої зміни на вилку.

    ``
    git push origin branch/name-here
    ``

## Запрошення запиту на виклик (PR)
Після внесення змін перевірте тут [як відкрити запит на витягнення] (/ docs / how-to-open-a-pull-request.md).

## Отримання довідки
Якщо ви застрягли і вам потрібна допомога, повідомте нас про це, запитавши в категорії ["Дописувачі" на нашому форумі](https://www.freecodecamp.org/forum/c/contributors) або в [кімнаті чату для учасників] (https : //gitter.im/FreeCodeCamp/Contributors) на Gitter.

Можливо, у консолі вашого веб-переглядача або в Bash / Terminal / Command Line буде помилка, яка допоможе визначити проблему. Введіть це повідомлення про помилку в описі проблеми, щоб інші могли легше визначити проблему та допомогти знайти рішення.

### Вирішення проблем
Якщо програма запускається, але у вас виникають помилки інтерфейсу користувача, такі як шрифти не завантажуються або редактор коду не відображається належним чином, перегляньте наступне, залежно від локальної установки:

** Створення докера: **
``
# Ми використовуємо моно репо і маємо декілька компонентів (сервер, клієнт, інструменти, плагіни тощо)
# Використовуйте цю команду для очищення всіх залежностей у всіх компонентах
npm run docker: clean

# Перевстановити пакети npm
npm run docker: install

# Посіяти базу даних
npm run docker: seed

# Перезавантажте програму
npm run docker: develop
``

** Місцевий збір: **
``
npm run clean
npm ci
npm run seed
npm run develop
``

Якщо ви не можете ввійти, а натомість ви бачите банер із повідомленням про помилку, в якому йдеться про те, що про нього буде повідомлено freeCodeCamp, перевірте, чи ваш локальний порт 3000 не використовується іншою програмою.

Якщо ви отримуєте помилки під час встановлення залежностей, переконайтеся, що ви не перебуваєте в мережі з обмеженими можливостями, або якщо налаштування брандмауера не заважають вам отримувати доступ до ресурсів. Одним із варіантів рішення буде використання послуги VPN, якщо це можливо та дозволено у вашому оточенні.